
/*
 * (a)  (C) 1990 by Adobe Systems Incorporated. All rights reserved.
 *
 * (b)  If this Sample Code is distributed as part of the Display PostScript
 *	System Software Development Kit from Adobe Systems Incorporated,
 *	then this copy is designated as Development Software and its use is
 *	subject to the terms of the License Agreement attached to such Kit.
 *
 * (c)  If this Sample Code is distributed independently, then the following
 *	terms apply:
 *
 * (d)  This file may be freely copied and redistributed as long as:
 *	1) Parts (a), (d), (e) and (f) continue to be included in the file,
 *	2) If the file has been modified in any way, a notice of such
 *      modification is conspicuously indicated.
 *
 * (e)  PostScript, Display PostScript, and Adobe are registered trademarks of
 *	Adobe Systems Incorporated.
 * 
 * (f) THE INFORMATION BELOW IS FURNISHED AS IS, IS SUBJECT TO
 *	CHANGE WITHOUT NOTICE, AND SHOULD NOT BE CONSTRUED
 *	AS A COMMITMENT BY ADOBE SYSTEMS INCORPORATED.
 *	ADOBE SYSTEMS INCORPORATED ASSUMES NO RESPONSIBILITY
 *	OR LIABILITY FOR ANY ERRORS OR INACCURACIES, MAKES NO
 *	WARRANTY OF ANY KIND (EXPRESS, IMPLIED OR STATUTORY)
 *	WITH RESPECT TO THIS INFORMATION, AND EXPRESSLY
 *	DISCLAIMS ANY AND ALL WARRANTIES OF MERCHANTABILITY, 
 *	FITNESS FOR PARTICULAR PURPOSES AND NONINFRINGEMENT
 *	OF THIRD PARTY RIGHTS.
 */

/*
 *	GraphicList.h
 *
 *	A subclass of list that acts like a GraphicEpsf object. Each message
 *	is performed on each object in the list.
 *
 *	Version:	2.0
 *	Author:	Ken Fromm
 *	History:
 *			03-19-91		Added this comment. Since the NXImage
 */

#import "ImportApp.h"
#import "epsfstruct.h"

#import <appkit/graphics.h>
#import <objc/List.h>

@interface GraphicList : List
{
}

- copy;
- copyTemp;
- freeTemp;

- replaceObjectsIn:aList  with:bList;
- removeObjectsIn:bList;
- insertObjectsIn:bList;

- setSelected:(BOOL) flag;

- rotateAboutPoint:(NXPoint *) aPoint  withAngle:(float) angle;
- moveAll:(const NXPoint *) pt;

- getBounds:(NXRect *)aRect;
- getScrollRect:(NXRect *)aRect  forPtNum:(int) pt_num;

- constrainAngle:(float *) angle  withFlags:(int)flags;

- hitControl:(const NXRect *)hitRect  :(int *) pt_num  forSize:(float) size;

- putControlPoints:(UPath *)buffer  forRect:(NXRect *)r  :(NXPoint *) lastPoint;
- drawObject:(NXRect *) r  withFlags:(int) flags  inView:view;

- addResources:(Resource *) resourceDoc  for:(NXRect *) r;

@end

