
/*
 * (a)  (C) 1990 by Adobe Systems Incorporated. All rights reserved.
 *
 * (b)  If this Sample Code is distributed as part of the Display PostScript
 *	System Software Development Kit from Adobe Systems Incorporated,
 *	then this copy is designated as Development Software and its use is
 *	subject to the terms of the License Agreement attached to such Kit.
 *
 * (c)  If this Sample Code is distributed independently, then the following
 *	terms apply:
 *
 * (d)  This file may be freely copied and redistributed as long as:
 *	1) Parts (a), (d), (e) and (f) continue to be included in the file,
 *	2) If the file has been modified in any way, a notice of such
 *      modification is conspicuously indicated.
 *
 * (e)  PostScript, Display PostScript, and Adobe are registered trademarks of
 *	Adobe Systems Incorporated.
 * 
 * (f) THE INFORMATION BELOW IS FURNISHED AS IS, IS SUBJECT TO
 *	CHANGE WITHOUT NOTICE, AND SHOULD NOT BE CONSTRUED
 *	AS A COMMITMENT BY ADOBE SYSTEMS INCORPORATED.
 *	ADOBE SYSTEMS INCORPORATED ASSUMES NO RESPONSIBILITY
 *	OR LIABILITY FOR ANY ERRORS OR INACCURACIES, MAKES NO
 *	WARRANTY OF ANY KIND (EXPRESS, IMPLIED OR STATUTORY)
 *	WITH RESPECT TO THIS INFORMATION, AND EXPRESSLY
 *	DISCLAIMS ANY AND ALL WARRANTIES OF MERCHANTABILITY, 
 *	FITNESS FOR PARTICULAR PURPOSES AND NONINFRINGEMENT
 *	OF THIRD PARTY RIGHTS.
 */

/*
 *	epsf.h
 *
 *	Contains the external declarations for the functions in
 *	epsfreader.c and epsfwriter.c.
 */
 
#import "epsfstruct.h"

#import <appkit/nextstd.h>
#import <appkit/tiff.h>
#import <objc/objc.h>

extern void  	CheckEpsfBinaryHeader(char **data, int *len);
extern int  	ReadEpsf(EpsfStruct *epsf);
const char 	*GetTypeComment(int type);

extern void	WriteEpsfProcSetDef();
extern void	WriteEpsfProcSetInit();
extern void	WriteEpsfProcSetTerm();

extern void  	WriteEpsfIllustratorBeg(NXRect  *bounds, NXRect *boundsOrig,
				float rotation, char *filename);
extern void  	WriteEpsfIllustratorInclude(char *name);
extern void  	WriteEpsfIllustratorEnd();

extern void  	WriteEpsfResource(id list, int i, int j);
extern void	WriteEpsfPreview(id  image);

extern int		WriteEpsf(const char *name, NXRect *bounds, NXRect *boundsOrig);

extern char	*ErrorEpsf(int errorcode);
