
/*
 * (a)  (C) 1990 by Adobe Systems Incorporated. All rights reserved.
 *
 * (b)  If this Sample Code is distributed as part of the Display PostScript
 *	System Software Development Kit from Adobe Systems Incorporated,
 *	then this copy is designated as Development Software and its use is
 *	subject to the terms of the License Agreement attached to such Kit.
 *
 * (c)  If this Sample Code is distributed independently, then the following
 *	terms apply:
 *
 * (d)  This file may be freely copied and redistributed as long as:
 *	1) Parts (a), (d), (e) and (f) continue to be included in the file,
 *	2) If the file has been modified in any way, a notice of such
 *      modification is conspicuously indicated.
 *
 * (e)  PostScript, Display PostScript, and Adobe are registered trademarks of
 *	Adobe Systems Incorporated.
 * 
 * (f) THE INFORMATION BELOW IS FURNISHED AS IS, IS SUBJECT TO
 *	CHANGE WITHOUT NOTICE, AND SHOULD NOT BE CONSTRUED
 *	AS A COMMITMENT BY ADOBE SYSTEMS INCORPORATED.
 *	ADOBE SYSTEMS INCORPORATED ASSUMES NO RESPONSIBILITY
 *	OR LIABILITY FOR ANY ERRORS OR INACCURACIES, MAKES NO
 *	WARRANTY OF ANY KIND (EXPRESS, IMPLIED OR STATUTORY)
 *	WITH RESPECT TO THIS INFORMATION, AND EXPRESSLY
 *	DISCLAIMS ANY AND ALL WARRANTIES OF MERCHANTABILITY, 
 *	FITNESS FOR PARTICULAR PURPOSES AND NONINFRINGEMENT
 *	OF THIRD PARTY RIGHTS.
 */

/*
 *	ImportApp.h
 *
 *	This class performs some of the global functions necessary to
 *	manage the application.
 *
 *	Version:	2.0
 *	Author:	Ken Fromm
 *	History:
 *			03-07-91		Added this comment.
 */

#import <appkit/Application.h>

#define  PTS_BUFFER		32
#define  OPS_BUFFER		18

#define  PTS_HITPOINT	12
#define  OPS_HITPOINT	6

#define  OP_SELECT		0
#define  OP_IMPORT		1

#define Notify(title, msg) NXRunAlertPanel(title, msg, "OK", NULL, NULL)

typedef struct _UPath {
	float 	* pts;
	int		num_pts;
	char		*ops;
	int		num_ops;
} UPath;
	
@interface ImportApp : Application
{
	id		resourcePanel,	/* the id of the resourcePanel */
			importId,			/* the id of the import cursor */
			documentId;		/* the id of the current document */

	int		operation;		/* the current operation. */

	BOOL	contextFlag,		/* use a separate context for eps files */
			showEpsfFlag, 	/* show the epsf buffering windows */
			tracingFlag;		/* determines whether tracing should be turned on */

	UPath	hitPoint,			/* a global user path structure for the hit detection pt. */
			upathBuffer;		/* a buffer for holding data for the server */
}

+ new;

- free;
- initializeSelf;

- setSaveAccessory:anObject;

- setContextFlag:sender;
- (BOOL) contextFlag;
- setShowEpsfFlag:sender;
- (BOOL) showEpsfFlag;
- setTracingFlag:sender;
- (BOOL) tracingFlag;

- (UPath *) hitPoint;
- (UPath *) upathBuffer;

- resourcePanel;
- cursor;
- setOperation:(int) op;
- (int) operation;

- appDidInit:sender;

@end

