
/*
 * (a)  (C) 1990 by Adobe Systems Incorporated. All rights reserved.
 *
 * (b)  If this Sample Code is distributed as part of the Display PostScript
 *	System Software Development Kit from Adobe Systems Incorporated,
 *	then this copy is designated as Development Software and its use is
 *	subject to the terms of the License Agreement attached to such Kit.
 *
 * (c)  If this Sample Code is distributed independently, then the following
 *	terms apply:
 *
 * (d)  This file may be freely copied and redistributed as long as:
 *	1) Parts (a), (d), (e) and (f) continue to be included in the file,
 *	2) If the file has been modified in any way, a notice of such
 *      modification is conspicuously indicated.
 *
 * (e)  PostScript, Display PostScript, and Adobe are registered trademarks of
 *	Adobe Systems Incorporated.
 * 
 * (f) THE INFORMATION BELOW IS FURNISHED AS IS, IS SUBJECT TO
 *	CHANGE WITHOUT NOTICE, AND SHOULD NOT BE CONSTRUED
 *	AS A COMMITMENT BY ADOBE SYSTEMS INCORPORATED.
 *	ADOBE SYSTEMS INCORPORATED ASSUMES NO RESPONSIBILITY
 *	OR LIABILITY FOR ANY ERRORS OR INACCURACIES, MAKES NO
 *	WARRANTY OF ANY KIND (EXPRESS, IMPLIED OR STATUTORY)
 *	WITH RESPECT TO THIS INFORMATION, AND EXPRESSLY
 *	DISCLAIMS ANY AND ALL WARRANTIES OF MERCHANTABILITY, 
 *	FITNESS FOR PARTICULAR PURPOSES AND NONINFRINGEMENT
 *	OF THIRD PARTY RIGHTS.
 */

/*
 *	NXBitmapImageRepSub.h
 *
 *	A subclass of NXBitmapImageRep. Enhanced to handle rotation
 *	and resources. The method drawIn:rect with:rotation performs
 *	many of the same steps as drawIn but adds the rotation. The
 *	filename if it exists is added to the resources list at the appropriate
 *	spot.
 *
 *	Version:	2.0
 *	Author:	Ken Fromm
 *	History:
 *			03-28-91		Created the file. 
 *
 */

#import <appkit/NXBitmapImageRep.h>
#import <objc/hashtable.h>
#import "resources.h"

@interface NXBitmapImageRepSub : NXBitmapImageRep
{
}

- addResources:(Resource *) resourceDoc  forFile:(NXAtom) fileName;

- (BOOL) drawIn:(NXRect *) r  with:(float) rotation;

@end

