
/*
 * (a)  (C) 1990 by Adobe Systems Incorporated. All rights reserved.
 *
 * (b)  If this Sample Code is distributed as part of the Display PostScript
 *	System Software Development Kit from Adobe Systems Incorporated,
 *	then this copy is designated as Development Software and its use is
 *	subject to the terms of the License Agreement attached to such Kit.
 *
 * (c)  If this Sample Code is distributed independently, then the following
 *	terms apply:
 *
 * (d)  This file may be freely copied and redistributed as long as:
 *	1) Parts (a), (d), (e) and (f) continue to be included in the file,
 *	2) If the file has been modified in any way, a notice of such
 *      modification is conspicuously indicated.
 *
 * (e)  PostScript, Display PostScript, and Adobe are registered trademarks of
 *	Adobe Systems Incorporated.
 * 
 * (f) THE INFORMATION BELOW IS FURNISHED AS IS, IS SUBJECT TO
 *	CHANGE WITHOUT NOTICE, AND SHOULD NOT BE CONSTRUED
 *	AS A COMMITMENT BY ADOBE SYSTEMS INCORPORATED.
 *	ADOBE SYSTEMS INCORPORATED ASSUMES NO RESPONSIBILITY
 *	OR LIABILITY FOR ANY ERRORS OR INACCURACIES, MAKES NO
 *	WARRANTY OF ANY KIND (EXPRESS, IMPLIED OR STATUTORY)
 *	WITH RESPECT TO THIS INFORMATION, AND EXPRESSLY
 *	DISCLAIMS ANY AND ALL WARRANTIES OF MERCHANTABILITY, 
 *	FITNESS FOR PARTICULAR PURPOSES AND NONINFRINGEMENT
 *	OF THIRD PARTY RIGHTS.
 */

/*
 *	DocView.h
 *
 *	This class allows the drawing view to be positioned in the center
 *	of the clip view and a border and drop shadow placed around it
 *	when the drawing view is scaled to be smaller than the clip view.
 *	This class also handles the zooming of the drawing view.
 *
 *	Version:	2.0
 *	Author:	Ken Fromm
 *	History:
 *			03-07-91		Added this comment.
 */

#import <appkit/View.h>

#define OFFSET		8
#define LINEWIDTH	6

@interface DocView : View
{
	id		zoomCursor;		/* the zoom cursor. */
	id		zoomControl;		/* the matrix of radio buttons for zooming. */
	id		drawView;		/* the drawing view */

	BOOL	zooming;
	
	float		scale;			/* the scale of the drawing view */
}

- addDrawView:subView;

- setZoomControl:anObject;
- zoomControl;

- setScale:(float) value;
- (float) scale;

- (BOOL) isZooming;

- resetCursorRects;
- zoom:sender;

- rotateDrawView;

- sizeDrawViewWithScale:(float) newscale;
- scaleDrawViewWithScale:(float) newscale;
- placeDrawView;

- scaleDrawViewToPoint:(NXPoint *) p;
- scrollPoint:(const NXPoint *) aPt  to:(const NXPoint *) windowPt;

- drawSelf:(NXRect *)r :(int) count;

@end

