#import <appkit/Application.h>


@interface ContourPlotApp:Application
{
    id contourView;
    id horizCSView;		// horizontal cross section
    id vertCSView;		// vertical cross section
    id commentText;
    id versionField;
    id openPanel;

    id xposTextField;
    id yposTextField;

    id nlevelField;			// # of contour levels field
    id xgStepField;
    id ygStepField;			// y grid spacing field
    id nxField;				// original data X num points field
    id nyField;
    id nxInterpField;			// Field for X number of points to interpolate to
    id nyInterpField;			// Field for Y number of points to interpolate to
    id xminField;
    id xmaxField;
    id yminField;
    id ymaxField;
    id  dashMarkField;
    id  dashSpaceField;

    id tickSwitch;
    id gridSwitch;
    id axisSwitch;

    id brightCWell;
    id darkCWell;
    id bgCWell;
    id lineCWell;		/* line color */

    // controls for scaling options
    id  scaleSelectRadio;	/* auto - manual radio button */
    id  maxZplotField;
    id  minZplotField;
    id  maxZdataField;
    id  minZdataField;

    int zrange_in_file;
    int manual_scaling;
    float min_zval, max_zval;


    int nxInterp;			// X number of points to interpolate to
    int nyInterp;			// Y number of points to interpolate to

    // For curve plotting at cross sections
    float *xt, *yt;
    float *xcurve, *ycurve;

    // Actual data
    int		nx, ny;			// # of X Y points of loaded data
    float	xmin, xmax;
    float	ymin, ymax;
    float	*zdata;			// 2-d grid data
    float	xgstep, ygstep;		// grid increment
    const char *saveFile;
    char datafile[256];
}

- appDidInit:sender;
- openSample:sender;
- viewSampleFile:sender;

- (int)appOpenFile:(const char *)path type:(const char *)type;
- (BOOL)appAcceptsAnotherFile:sender;
- open:sender;
- openFile:(const char *)fileName;
- saveEPSRequest:sender;
- redisplayView;

- getMinMaxZplot;
- getMinMaxZdata;
- setMinMaxZplot:(float)min :(float)max;
- setMinMaxZdata:(float)min :(float)max;
- loadPlotRangeFromData:sender;		/* from button to set plot range */
- setZscaleMinMax:sender;		/* from Z-scaling Min Max fields */
- setAutoManualScaling:sender;		/* auto manual radio button's action */

- actionPrintCrossHair:sender;
- markerDidMove:(int)viewtag :(int)marker :(float)x :(float)y :(int)mup;
- setNcontourLevels:sender;
- setLineWidth:sender;
- setGridSpacing:sender;
- setNInterpolation:sender;

- clearAction:sender;
- drawAction:sender;
- colorWellsAction:sender;
- useColorAction:sender;
- setGridMesh:sender;
- setTickMark:sender;
- setAxis:sender;
- setMinNumberContour:sender;
- flipYAction:sender;
- setDash:sender;			/* set Dash pattern of contour */
- setStrokeContour:sender;

- windowDidResize:sender;

@end
