//
// Copyright 1995 (c) Icebox Software Manufactory, Inc.  All Rights Reserved.
//


#import <appkit/appkit.h>

#define MAXLINES	10

typedef struct _TANLine {
	NXPoint	begin;
	NXPoint	end;
} TANLine;


@interface LineView:View
{
	NXPoint		pt1;
	NXPoint		pt2;
	float		dx1;
	float		dx2;
	float		dy1;
	float		dy2;

	DPSTimedEntry	myTE;

	float		backingRed;
	float		backingGreen;
	float		backingBlue;
	float		backingAlpha;
	float		lineRed;
	float		lineGreen;
	float		lineBlue;
	float		lineAlpha;

	float		lineWidth;
	float		speed;

	TANLine		lines[MAXLINES];
	float		numberOfLines;
}

- clear;
- start;
- stop;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- _moveIt;
- lineColor:(NXColor)newColor;
- backingColor:(NXColor)newColor;
- lineWidth:(float)newLineWidth;
- speed:(float)newSpeed;
- numberOfLines:(float)newNumberOfLines;

@end
