
#import "BlockedSquare.h"

@implementation BlockedSquare

#define FRACTION  0.5
#define BORDER    ((1 - FRACTION) / 2)

- drawSelf: (const NXRect *) rects : (int) rectCount {
    NXRect block = { bounds.origin.x + BORDER * bounds.size.width,
		     bounds.origin.y + BORDER * bounds.size.height,
		     FRACTION * bounds.size.width,
		     FRACTION * bounds.size.height };

    [super drawSelf: rects : rectCount];
    PSsetgray(NX_DKGRAY);
    NXRectFill(&block);
    return self;
}

/* Private methods: */

- appDidInit {
    return self;	/* does nothing (sets no tracking rectangle) */
}

@end
