/* -------------------------------------------------------------------

	RDR, Inc. 

	Objective-C interface file for the class AppWithDoc

	COPYRIGHT (C), 1991, RDR, Inc.
	ALL RIGHTS RESERVED.

	Responsible:			Approved:
	RDR:Ernest Prabhakar		

	Date:				Rev:
	1991-Oct-12			___

	Reference:			Document no:
 */

/*====================================================================
                    Interface of class AppWithDoc                     
====================================================================*/
#import <appkit/Application.h>

@interface AppWithDoc : Application
{
    char *  extension;	/* file extension for documents */
    id      docClass;		/* Class of Document to use */
    float   version;		/* The number to put there */
    id      inspectorPanel;	/* the shared inspector panel */
    id      findPanel;		/* the shared inspector panel */
    id 	    marginsAddon;	/* Margins for Page Layout */
    id 	    saveToAddon;	/* Save to different Types */
    
    BOOL haveOpenedDocument;	/* whether we have opened a document */
}

/* ------------------ Factory Methods - Creation ------------------ */
+new;
-setDocClass:newDoc;
-docClass;
-setVersion:(int)newVersion;

/* ------------------ Application-Wide Services ------------------- */
-readFromFile:(const char *)filename;
-write:anObject toFile:(const char *)filename;
-locateWindow:aWindow;
-defaultFont;
-defaultFont:(const char *)fontName;
-loadZonedNibSection:(const char *)nibName;

/* ----------------- Application-wide shared info ----------------- */
-currentDocument;
-(const char *)currentDirectory;
-(const char *)extension;
-saveAsPanel;
-saveToPanel;
-findPanel:sender;
-inspectorPanel:sender;
-pageLayout;

/* ------------------------ Action Methods ------------------------ */
-info:sender;
-new:sender;
-open:sender;
-openTypes:(const char * const *)docTypes using:aClass;;
-saveAll:sender;
-print:sender;
-terminate:sender;

/* ----------------------- Delegate Methods ----------------------- */
-appDidInit:sender;
-(int)appOpenFile:(const char *)path type:(const char *)type;
-(BOOL) appAcceptsAnotherFile:sender;

/* --------------- Listener/Speaker remote methods ---------------- */
-(int)msgVersion:(char* *)aString ok:(int *)flag;
-(int)msgDirectory:(const char **)totalPath ok:(int *)flag;
-(int)msgFile:(const char **)totalPath ok:(int *)flag;
-(int)msgPrint:(const char *)fullPath ok:(int *)flag;
-(int)msgQuit:(int *)flag;

/* ------------------- Automatic update methods ------------------- */
-(BOOL)menuItemUpdate:menuCell;
-(BOOL)validateCommand:menuCell;

@end
