/* -------------------------------------------------------------------

	RDR, Inc. 

	Objective-C interface file for the class Card

	COPYRIGHT (C), 1991, RDR, Inc.
	ALL RIGHTS RESERVED.

	Responsible:			Approved:
	RDR:Ernest Prabhakar		

	Date:				Rev:
	1991-Jul-01			___

	Reference:			Document no:
 */

/*====================================================================
                       Interface of class Card                        
====================================================================*/
#import <objc/Storage.h>

typedef struct _CardData {
	char *stringValue;
	int stringLength;
	int intValue;	
	float floatValue;
	id object; } CardData;
#define cardDescription "{*iif@}"
#define CardFieldAt(C,F) ((CardData*)[C elementAt:F])
#define CardStringField(C,F) (CardFieldAt(C,F)->stringValue)

enum {SortStrings, SortInts, SortFloats, SortObjects};

@interface Card : Storage
{

    

}

/* ----------------------- Factory Methods ------------------------ */
+setActiveField:(unsigned)field;
+(unsigned)activeField;
+setSortFlag:(int)flag;
+(int)sortFlag;

/* --------------------- Initialize and Free ---------------------- */
-init;
-initCount:(unsigned)count;
-free;

/* ----------------- Importing and Exporting Data ----------------- */
-importFrom:(NXStream *)stream;
-exportTo:(NXStream *)stream;

/* ---------------------- String Fields I/O ----------------------- */
-setStringValue:(const char *)aString;
-setStringValue:(const char *)aString at:(int)field;
-setStringValueNoCopy:(char *)aString;
-setStringValueNoCopy:(char *)aString at:(int)field;
-setStringValueFrom:(NXStream *)aStream;
-setStringValueFrom:(NXStream *)aStream at:(unsigned)field;
-(const char *)stringValue;
-(const char *)stringValueAt:(unsigned)field;
-(NXStream *)stringStream;
-(NXStream *)stringStreamAt:(unsigned)field;

/* ------------------------- Integer I/O -------------------------- */
-setIntValue:(int)anInt;
-setIntValue:(int)anInt at:(unsigned)field;
-(int)intValue;
-(int)intValueAt:(unsigned)field;

/* -------------------------- Float I/O --------------------------- */
-setFloatValue:(float)aFloat;
-setFloatValue:(float)aFloat at:(unsigned)field;
-(float)floatValue;
-(float)floatValueAt:(unsigned)field;

/* -------------------------- Object I/O -------------------------- */
-setObject:anObject;
-setObject:anObject at:(unsigned)field;
-object;
-objectAt:(unsigned)field;

/* --------------------- Finding and Sorting ---------------------- */
-findSTR:(const char *) aString;
-(int)compare:aCard;
-rotate;

@end
