/* -------------------------------------------------------------------

	RDR, Inc. 

	Objective-C interface file for the class FlashDoc

	COPYRIGHT (C), 1991, RDR, Inc.
	ALL RIGHTS RESERVED.

	Responsible:			Approved:
	RDR:Ernest Prabhakar		

	Date:				Rev:
	1991-Oct-14			___

	Reference:			Document no:
 */

/*====================================================================
                     Interface of class FlashDoc                      
====================================================================*/
#import "BasicApp.h"
enum {KEY, RES, NTextViews};

@interface FlashDoc : Document
{
    BOOL viewMode;
    BOOL cardChanged;
    id textView[NTextViews];
    id rand;
    id reveal;
    id diff;
    id markCount;
    unsigned int current;
}

/* ---------------------- Initialize Methods ---------------------- */
-getWindow;

/* ------------------------- Provide Card ------------------------- */
-nextCard;
-addCard;
-(BOOL)sync;
/* --------------------- Card Display Methods --------------------- */
-showCard;
-saveCard;

/* ----------------------- State Variables ------------------------ */
-view;
-(BOOL) viewMode;;
-setViewMode:(BOOL)newMode;
-switchViewMode:sender;

/* ------------------------ Action Methods ------------------------ */
-reveal:sender;
-cover:sender;
-wasEasy:sender;
-wasFair:sender;
-wasHard:sender;

/* -------------------------- Edit Mode --------------------------- */
-next:sender;
-revertCard:sender;
-modify:sender;
-delete:sender;

/* ----------- Action Methods for manipulating the Deck ----------- */
-previous:sender;
-find:sender;
-doAct:(SEL)action for:(STR)caller;
-shuffle:sender;
-sort:sender;
-swapFields:sender
/*
 * Exchange Key and Response.
 */;
- reset:sender;

/* --------------- Action Methods for File services --------------- */
- print:sender
/*
 * Create a view displaying the entire deck, staggered.  Then print it.
 */;

/* -------------------- Text delegate methods. -------------------- */
-(BOOL)textWillChange:sender;

@end
