
//
// Defs for both 
// the Speaker/Listener based API and 
// the Distributed Object Based API
//

#define GRAPHITY_NO_SUCH_DOCUMENT	-1
#define GRAPHITY_NO_SUCH_GRAPH		-2

#define GRAPHITY_DONT_DISPLAY	0
#define GRAPHITY_DISPLAY	1
#define GRAPHITY_RECALCULATE	2

#define GRAPHITY_OK	0
#define GRAPHITY_ERROR	-1


#define GRAPHITY_SAVE		0
#define GRAPHITY_SAVE_AS	1
#define GRAPHITY_SAVE_TO	2

#define GRAPHITY_OPEN		0
#define GRAPHITY_COPY		1
#define GRAPHITY_READONLY	3	// note, not 2

#define GRAPHITY_BAR_GRAPH		0
#define GRAPHITY_LINE_GRAPH		1
#define GRAPHITY_AREA_GRAPH		2
#define GRAPHITY_PIE_GRAPH		3
#define GRAPHITY_SCATTER_GRAPH		4
#define GRAPHITY_3DBAR_GRAPH		5
#define GRAPHITY_3DAREA_GRAPH		6
#define GRAPHITY_3DPIE_GRAPH		7

#define GRAPHITY_STOCK_GRAPH		8
#define GRAPHITY_3DSCATTER_GRAPH	9
#define GRAPHITY_COMBINED_GRAPH		10


#define GRAPHITY_SERVER	"GraphityServer"
#define GRAPHITY_NAME	"Graphity"

//
// The Distributed Objects based API
//


@protocol GraphityRootInterface
- API_openDocument:(const char *)path type:(in int)type;
- API_newDocument;
- API_quit;
- API_hide;
- API_unhide;
@end


@protocol GraphityDocumentInterface
- API_addGraph:(int)type with:(const char *)name;
- API_shapeDocument: (in NXRect *)aRect;
- API_findGraphWithName:(const char *)name;
- API_closeDocument:(in int)warn;
- API_hideDocument;
- API_unideDocument;
- API_saveDocument:(const char *)path type:(in int)type;
- API_saveDocument;
@end


@protocol GraphityGraphInterface
- API_recalculate;
- API_redisplay;
- API_addRow:(const char *)label;
- API_addSerie:(const char *)title;
- API_setValueAt:(in int)row : (int)serie to:(in double)value;
- API_setRowLabel:(const char *)label at:(in int)row;
- API_setSerieTitle:(const char *)label at:(in int)serie;
- API_setGraphType:(in int)type;
- API_getRowCount:(out int *)rcount serieCount:(out int *)scount;
- API_setFrame:(in NXRect *)aRect;
- API_readDataFromFile:(in const char *)path;
- API_readDataFromStream:(in NXStream *)stream;
- API_setBackgroundColor:(in NXColor)c;
- API_setBorderType:(in int)c;		
@end



