#import <appkit/appkit.h>
#import "Graphity_APISpeaker.h"
#import <mach/mach.h>
#import <mach/message.h>
#import <servers/netname.h>
extern port_t name_server_port;
extern id NXResponsibleDelegate();
@implementation  Graphity_APISpeaker :Speaker
{}
-(int)API_setValueAtRow : (int) row
	serie : (int) serie
	to : (double) v
	for : (char *) name
	in : (char *) doc
	display : (int) display
	error : (int *) error
/* */
{
return [self selectorRPC:"API_setValueAtRow:serie:to:for:in:display:error:"
	paramTypes:"iidcciI",
		row,
		serie,
		v,
		name,
		doc,
		display,
		error];
}
-(int)API_setLabelAt : (int) row
	to : (char *) label
	for : (char *) name
	in : (char *) doc
	display : (int) display
	error : (int *) error
/* */
{
return [self selectorRPC:"API_setLabelAt:to:for:in:display:error:"
	paramTypes:"iccciI",
		row,
		label,
		name,
		doc,
		display,
		error];
}
-(int)API_setSerieTitleFor : (int) serie
	to : (char *) label
	for : (char *) name
	in : (char *) doc
	display : (int) display
	error : (int *) error
/* */
{
return [self selectorRPC:"API_setSerieTitleFor:to:for:in:display:error:"
	paramTypes:"iccciI",
		serie,
		label,
		name,
		doc,
		display,
		error];
}
-(int)API_redisplay : (char *) name
	in : (char *) doc
	error : (int *) error
/* */
{
return [self selectorRPC:"API_redisplay:in:error:"
	paramTypes:"ccI",
		name,
		doc,
		error];
}
-(int)API_recalculate : (char *) name
	in : (char *) doc
	error : (int *) error
/* */
{
return [self selectorRPC:"API_recalculate:in:error:"
	paramTypes:"ccI",
		name,
		doc,
		error];
}
-(int)API_newDocument : (char *) name
	error : (int *) error
/* */
{
return [self selectorRPC:"API_newDocument:error:"
	paramTypes:"cI",
		name,
		error];
}
-(int)API_saveDocument : (char *) name
	type : (int) type
	to : (char *) path
	error : (int *) error
/* */
{
return [self selectorRPC:"API_saveDocument:type:to:error:"
	paramTypes:"cicI",
		name,
		type,
		path,
		error];
}
-(int)API_shapeDocument : (char *) name
	x : (double) x
	y : (double) y
	width : (double) w
	height : (double) h
	error : (int *) error
/* */
{
return [self selectorRPC:"API_shapeDocument:x:y:width:height:error:"
	paramTypes:"cddddI",
		name,
		x,
		y,
		w,
		h,
		error];
}
-(int)API_closeDocument : (char *) name
	warn : (int) warn
	error : (int *) error
/* */
{
return [self selectorRPC:"API_closeDocument:warn:error:"
	paramTypes:"ciI",
		name,
		warn,
		error];
}
-(int)API_openDocument : (char *) path
	type : (int) type
	error : (int *) error
/* */
{
return [self selectorRPC:"API_openDocument:type:error:"
	paramTypes:"ciI",
		path,
		type,
		error];
}
-(int)API_addGraph : (int) type
	with : (char *) name
	in : (char *) doc
	error : (int *) error
/* */
{
return [self selectorRPC:"API_addGraph:with:in:error:"
	paramTypes:"iccI",
		type,
		name,
		doc,
		error];
}
-(int)API_addSerie : (char *) title
	for : (char *) name
	in : (char *) doc
	error : (int *) error
/* */
{
return [self selectorRPC:"API_addSerie:for:in:error:"
	paramTypes:"cccI",
		title,
		name,
		doc,
		error];
}
-(int)API_addRow : (char *) label
	for : (char *) name
	in : (char *) doc
	error : (int *) error
/* */
{
return [self selectorRPC:"API_addRow:for:in:error:"
	paramTypes:"cccI",
		label,
		name,
		doc,
		error];
}
-(int)API_shapeGraph : (char *) name
	in : (char *) doc
	x : (double) x
	y : (double) y
	width : (double) w
	height : (double) h
	error : (int *) error
/* */
{
return [self selectorRPC:"API_shapeGraph:in:x:y:width:height:error:"
	paramTypes:"ccddddI",
		name,
		doc,
		x,
		y,
		w,
		h,
		error];
}
-(int)API_setGraphTypeFor : (char *) name
	in : (char *) doc
	to : (int) type
	error : (int *) error
/* */
{
return [self selectorRPC:"API_setGraphTypeFor:in:to:error:"
	paramTypes:"cciI",
		name,
		doc,
		type,
		error];
}
-(int)API_readDataFrom : (char *) file
	graph : (char *) name
	in : (char *) docname
	error : (int *) error
/* */
{
return [self selectorRPC:"API_readDataFrom:graph:in:error:"
	paramTypes:"cccI",
		file,
		name,
		docname,
		error];
}
-(int)API_getGraphSize : (char *) name
	in : (char *) docname
	rowCount : (int *) rowCount
	serieCount : (int *) serieCount
	error : (int *) error
/* */
{
return [self selectorRPC:"API_getGraphSize:in:rowCount:serieCount:error:"
	paramTypes:"ccIII",
		name,
		docname,
		rowCount,
		serieCount,
		error];
}
@end
