/*
**	LispApp.m
**	Appkit-based front-end for a separate lisp process.
**	Lee Boynton, NeXT, Inc., 1989
*/

#import <appkit/Application.h>

@interface LispApp:Application
{
    id listener;
}

- setListener:anObject;
    /*
    ** Provided to set the listener outlet via IB.
    */

- (int)appEvaluate:(char *)theString;
    /*
    ** This appkit Speaker-compatible message allows other apps to send
    ** an 'evaluate' message to lisp (for example, and editor might use
    ** this to implement an 'eval-region' command).
    */

- (BOOL)appAcceptsAnotherFile:sender;
- (int)appOpenFile:(const char *)path type:(const char *)type;
    /*
    ** Workspace Manager interface to open documents. Documents with the
    ** .lisp or .fasl (source and compiled, respectively), are automatically
    ** loaded into lisp when double clicked on from Workspace.
    */

@end

