
/* Generated by Interface Builder */

#import <objc/Object.h>
#import <appkit/Matrix.h>
#import <appkit/NXBrowser.h>
#import "MetroTools.h"
#import "MTool.h"

/* defines and structs */

/* tool file type */
#define TOOLFILETYPE	".mTool"

/* loaded tool module list */
typedef struct
{
	MTool	*theTool;			/* id of tool instance */
	char	toolName[128];		/* name string for tool */
	char	iconName[128];		/* name string for tool icon */
	View	*toolView;			/* the view of the tool's controls */
	unsigned short toolFlags;	/* runtime flags for tool */
} ToolRec;

typedef struct
{
	short	nTools;			/* # of tools in list */
	short	curTool;		/* current tool */
	ToolRec	tools[0];		/* list of loaded tools */
} ToolList;

	
@interface ToolController:Object
{
	/* from IB */
    Matrix		*ToolView;
    id			ToolControls;
    id			HelpView;
	id			HelpText;
	id			stringTable;
	Window		*MainWindow;
	Window		*HelpWindow;
	Window		*TimeBombWind;
	id			ToolScrollView;
	id			DemoText1;
	id			DemoText2;
	id			DemoText3;
	id			ExpandButton;
	BOOL		firstShow;
	NXSize		minWindSize;
	NXSize		normWindSize;
	BOOL		windIsShrunk;
	
	/* tool list variables */
	ToolList	*theTools;
	
	/* drag and drop variables */
	BOOL		supportsDrop,doFolders;
	id			iconView;
	id			fileNameTextField;
    int			filePathLength;
    char		*filePath;
    BOOL		multipleFiles;
	char		*inp,*newp;
	int 		files;
	id			dirS;
	BOOL		dirOpen;
}

/* IB methods */
- ToolSelect:sender;
- ToolHelp:sender;
- MenuHelp:sender;
- ShowPrefs:sender;
- ResizeMainWindow:sender;

/* non-IB methods */
- init;
- appDidInit:sender;
- (BOOL)checkTimeBomb;
- closeBombWind:sender;
- appWillTerminate:sender;
- (int)iconEntered:(int)windowNum at:(double)x :(double)y
    iconWindow:(int)iconWindowNum iconX:(double)iconX iconY:(double)iconY
    iconWidth:(double)iconWidth iconHeight:(double)iconHeight
    pathList:(char *)pathList;
- (int)iconReleasedAt:(double)x :(double)y ok:(int *)flag;
- (int)MTdoNext:sender;
- (void)MTdoFolders:(BOOL)how;

/* support methods */
- (BOOL) isDir:(char *)path;
- (void) accessFile:(char *)path : (BOOL *) readAccess : (BOOL *) writeAccess;
- DisplayHelp:(NXStream*)s;

@end
