
/*
	mTool.h - This is the interface of the shell for a MetroTools module. 
	
		This interface and the accompanying instructions are for MetroTools 
		version 1.0.x, and for NeXTstep version 2.x.
		
		Creating a MetroTools 'Tool' project: To create a MetroTools 'Tool' in 
		IB, you must select 'New Module' from a  fresh IB session, and name the 
		module class as 'mtClass(toolname)' where (toolname) is the name of the 
		tool as you would like it to appear. Set the class as a subclass of 
		Object. When creating the project in the Project Inspector, set it as 
		an IB palette project.
		
		There are a few things that MetroTools requires it's modules to 
		provide. 
		
			First, is that the name of the main class of the module must 
			have the prefix 'mtClass', with the rest of the name being the tool 
			name. 
			
			Second, is that the 'mtClass' object is instantiated, and is named 
			the same as the module name.
			
			Third, is that the module must have an associated Icon in the 
			project named '(toolname)Icon', where (toolname) is the name of the 
			tool used in the main class name. This icon is used in MetroTool's 
			scolling list of modules, and is the only way for users to identify 
			which module to choose. 
			
			Fourth, is that the module provides a window which contains it's 
			module controls. MetroTools takes the controls out of this window 
			and installs them into it's tool control area when the tool is 
			selected.
		
	Version: 1.0 - 5/30/92
	Copyright 1992 by Metrosoft, All Rights Reserved.
*/

#import <objc/Object.h>
#import <appkit/Window.h>

@interface MTool:Object
{
}

/* MetroTools methods */

- GetToolWindow:(Window**)theWind;

- DisplayPrefs;

- (BOOL) DisplayHelp;

- InitSelf:(unsigned short*)toolFlags;

- doActivate;

- doDeactivate;

- unload;

/* drag-and-drop routines */

- (BOOL)MTiconEntered:(id*)iconView:(id*)fileNameTextField:(BOOL*)doFolders;

- (void)MTiconExited:sender;
   
- (void)MTiconReleased:sender;

- (BOOL)MTprocessFile:(char*)name;

- (void)MTfinished:sender;

@end
