
/*
	ssClassModule.h - This is the interface of the shell for a NiteLite module.
	
		This interface and the accompanying instructions are for MetroTools
		version 1.0.x, for NiteLite version 1.0.x, and for NeXTstep version
		2.x.
		
		Creating a NiteLite 'module' project: To create a NiteLite module in 
		IB, you must select 'New Module' from a fresh IB session, and name the 
		module class as 'ssClass(modulename}' where (modulename) is the name of 
		the NiteLite module as you would like it to appear in NiteLite. Set the 
		class as a subclass of Object. When creating the project in the Project 
		Inspector, set it as an IB palette project.
		
		Here are some things that NiteLite requires it's modules to have:
		
			- The name of the main class of the module must have the prefix 
			'ssClass', with the rest of the name being the module name.
			
			- The 'ssClass' object must be instantiated and have it's name 
			match the module's name.
			
			- The module provides a window to NiteLite that contains the user 
			controls. NiteLite installs these controls into the NiteLite Module 
			Control Area of the main panel.
			
	Version: 1.0 - 6/3/92
	Copyright 1992 by Metrosoft, All Rights Reserved.
*/

#import <objc/Object.h>
#import <appkit/Window.h>
#import <appkit/View.h>
#import "mtClassNiteLite.h"

@interface ssClassModule:Object
{
}

- initSelf:(BOOL)ifOnly;

- doActivate:(mtClassNiteLite*)ssTool;

- doDeactivate;

- unload;

- getSettings: (void**)data: (int*)size;

- setSettings: (void*)data: (int)size;

- getControlsWindow:(Window**)theWind;

- prepDraw:(BOOL)inFore;

- drawFrame:(View*)theView:(NXRect*)obsList:(int)nRects:(BOOL*)didDraw:
	(NXColor)backColor;

- endDraw;

@end
