/*----------------------------------------------------------------------------
						METROTOOLS SCREEN SAVER HEADER
						
	This is the global header file for the MetroTools ScreenSaver Tool. It is
	for use with the ScreenSaver tool module, controller app, and display
	modules. It defines the data that is passed between the various parts of
	the screen saver.
	
	filename: ScreenSaver.h
	author: Ron Miller
	date: 12/15/91
	
	modification history:

----------------------------------------------------------------------------- */

#import "MetroTools.h"

/* module types */
enum
{
	MODTYPE_MTSS,	/* MetroTool ScreenSaver */
	MODTYPE_BACKSP	/* BackSpace module */
};

/* file extenders for module types */
#define MODEXT_MTSS		".ssMod"
#define MODEXT_BACKSP	".o"

/* ScreenSaver module directory */
#define SSDIRNAME		"NiteLiteModules/"


/* ScreenSaver Controller App Name */
#define SSAPPNAME		"ssController"

/* ScreenSaver Controller listener port name */
#define SSPORTNAME		"mtSSControllerApp"


/* ScreenSaver Controller App remote Methods */
#define SSRMT_DEMO		"DemoScreenSaver"
#define SSRMT_LOCK		"DoLockScreen"
#define SSRMT_PREF		"PrefFileChanged"
#define SSRMT_TERM		"doTerminate"


/* prefs file name */
#define SSPREFNAME	"ScreenSaver.prefs"

/* pref file id */
#define SSPREFID	0xFF00FF00

/* pref file version */
#define SSPREFVERS	100

/* prefs file data structure */
typedef struct
	{
		/* ss pref file verification */
		long	prefID;
		int		prefVers;
		
		/* control parameters */
		BOOL	useAutoLock;
		
		/* module info */
		char	foreModName[MAXNAMLEN+1];	/* path or "" if default module */
		char	backModName[MAXNAMLEN+1];
		BOOL	foreActive;
		BOOL	backActive;
		int		foreModType;
		int		backModType;
		NXColor	foreColor;
		NXColor	backColor;
		int		foreDataSize;
		int		backDataSize;
		void	*foreData;
		void	*backData;
	} ssPrefRec, *ssPrefPtr;

/* external routines */
extern unsigned currentTimeInMs();

