
/* 
	ssClassBlob.h - This is a sample NiteLite module which illustrates how a 
	NiteLite module is written. See the shell file 'ssClassModule.h' and the 
	document 'ToolsAPI.wn' for more information. You are welcome to use any 
	code in this file in your development of a MetroTools' NiteLite module.
	
	Author: Ron Miller
	Date: 6/17/92
	Version: 1.0  
	Copyright: 1992 Metrosoft, All Rights Reserved.
*/

#import <objc/Object.h>
#import <appkit/Window.h>
#import <appkit/View.h>
#import "mtClassNiteLite.h"

#define MAXSEGS	10

/* drawing control structure */
typedef struct
	{
		NXPoint	ctlPts[2];
		NXPoint	ctlIncs[2];
	} curveRec;
	
typedef struct
	{
		float		hVal, sVal, bVal;
		float		hInc, sInc, bInc;
		BOOL		isNew;
		curveRec	segs[MAXSEGS];
	} blobRec;

@interface ssClassBlob:Object
{
	/* IB parameters */
    id	toolWind;
    id	delaySlider;
    id	nSegSlider;
    id	nSegText;
	
    /* saved mtClassNiteLite parameter */
    id			screenSaver;
    
    /* control parameters */
    int			delayTime;
    int			nSegs;
    
    /* display control variables */
    unsigned	dispTime;
	blobRec		blob;
}

/* IB methods */
- NSegTextControl:sender;
- DelayControl:sender;
- NSegSlideControl:sender;

/* NiteLite methods */
- initSelf:(BOOL)ifOnly;
- doActivate:(mtClassNiteLite*)ssTool;
- doDeactivate;
- unload;
- getSettings: (void**)data: (int*)size;
- setSettings: (void*)data: (int)size;
- getControlsWindow:(Window**)theWind;
- prepDraw:(BOOL)inFore;
- drawFrame:(View*)theView:(NXRect*)obsList:(int)nRects:(BOOL*)didDraw:
	(NXColor)backColor;
- endDraw;

/* support drawing methods */
- initBlob:(NXRect*)frame;
- drawBlob;
- incBlob:(NXRect*)frame;

@end
