
/* 
	mtClassHexViewer.h - This is a sample MetroTools tool module which 
	illustrates how a tool module is written. See the shell file 'MTool.h' and 
	the document 'ToolsAPI.wn' for more information. You are welcome to use any 
	code in this file in your development of a MetroTools' tool module.
	
	Author: Kathryn Koploy-Miller
	Date: 6/17/92
	Version: 1.0  
	Copyright: 1992 Metrosoft, All Rights Reserved.
*/

#import <objc/Object.h>
#import <appkit/Window.h>

@interface mtClassHexViewer:Object
{
	/* IB parameters */
    id	toolWindow;
    id	iconWell;
    id	textScrollArea;
    id	prefsWindow;
    id	fileNameText;
}

/* MetroTools methods */

- GetToolWindow:(Window**)theWind;

- DisplayPrefs;

- (BOOL) DisplayHelp;

- InitSelf:(unsigned short*)toolFlags;

- doActivate;

- doDeactivate;

- unload;

/* drag-and-drop routines */

- (BOOL)MTiconEntered:(id*)iconView:(id*)fileNameTextField:(BOOL*)doFolders;

- (void)MTiconExited:sender;
   
- (void)MTiconReleased:sender;

- (BOOL)MTprocessFile:(char*)name;

- (void)MTfinished:sender;

/* support methods */

- loadFileAsHex:(char*)name;


@end
