
/*
 *      You may freely copy, distribute and reuse the code
 *      in this example.  NeXT disclaims any warranty of
 *      any kind, expressed or implied, as to its fitness
 *      for any particular use.
 *
 *      Written by: Susan Rayl
 *
 *      Created 21-Mar-91
 */

#import <appkit/TextFieldCell.h>
#import <appkit/Text.h>

@interface DateTFCell:TextFieldCell
{
	NXTextFilterFunc oldTextFilter; /* hold original filter func */
}

/* override these methods so that when the user TABs into the TextField or 
 * mouseDowns into the TextField, the filter function of the fieldEditor can be 
 * changed.  These are the two ways that a TextField can be enabled for taking 
 * user input so this is the place to control the user input.
 */
- select:(const NXRect *)aRect inView:controlView editor:textObj delegate:anObject start:(int)selStart length:(int)selLength;
- edit:(const NXRect *)aRect inView:controlView editor:textObj delegate:anObject event:(NXEvent *)theEvent;

/* override this method to remove the fieldEditor from the View hierarchy */
- endEditing:anObject;

/* the filter function for the DateTFCell and DateTextField */
char *dateFilter(id textObj, char *inputText, int *inputLength, int position);

@end
