
/*
 *      You may freely copy, distribute and reuse the code
 *      in this example.  NeXT disclaims any warranty of
 *      any kind, expressed or implied, as to its fitness
 *      for any particular use.
 *
 *      Written by: Susan Rayl
 *
 *      Created 21-Mar-91
 */

#import <appkit/TextFieldCell.h>
#import <appkit/Text.h>

@interface FilterTextCell:TextFieldCell
{
	NXTextFilterFunc oldTextFilter; /* hold the original filter func */
	NXTextFilterFunc newTextFilter; /* hold the current filter func */
}

/* set the instance variables */
- init;

/* override to get the original filter function and reset with the new */
- select:(const NXRect *)aRect inView:controlView editor:textObj delegate:anObject start:(int)selStart length:(int)selLength;
- edit:(const NXRect *)aRect inView:controlView editor:textObj delegate:anObject event:(NXEvent *)theEvent;

/* after the user has entered a value, reset the filter func to the original */
- endEditing:anObject;

@end
