
/*
 *      You may freely copy, distribute and reuse the code
 *      in this example.  NeXT disclaims any warranty of
 *      any kind, expressed or implied, as to its fitness
 *      for any particular use.
 *
 *      Written by: Susan Rayl
 *
 *      Created 21-Mar-91
 */

#import <appkit/TextField.h>
#import <appkit/Text.h>

@interface NameTextField:TextField
{
	NXTextFilterFunc oldTextFilter; /* hold the original filter func */
}

/* override these methods to set a new text filter function for the Text object
 * which acts as the FieldEditor for this TextField.
 */
- becomeFirstResponder;
- selectText:sender;

/* override this method to restore the original text filter function to the
 * Text object.
 */
- textDidEnd:anObject endChar:(unsigned short)whyEnd;

/* this is the text filter function which will be used by the Text object to
 * (possibly) manipulate the characters entered by the user.
 */
char *nameFilter(id textObj, char *inputText, int *inputLength, int position);

@end
