/* 
 * FindObject.h
 *
 * Purpose:
 *		This object controls the searching for strings in a matrix or in a text object.
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or  implied, as to its
 * fitness for any particular use.
 *
 * Written by: Mary McNabb
 * Created: Apr 91
 *
 */

#import <objc/Object.h>

#define TEXT 0
#define MATRIX 1

#define FORWARD 1
#define BACKWARD -1

@interface FindObject:Object
{
	id		findPanel;
	id		findForm;
	id		ignoreCaseButton;
	id		findNextButton;
	id		searchMe;
	BOOL	ignoreCase;
}

- init;
- setSearchMe:object;
- findNextReturn:sender;
- findNext:sender;
- findPrevious:sender;
- findInText:(int)direction;
- (BOOL)searchMatrixStrings:(int)start:(int)stop:(int)dir:(const char*)findStr;
- findInMatrix:(int) direction :(const char*) findStr;

@end
