/***** TranscriptManager.h -- recording/archiving object interface
	NeXTstep Measurement Kit
	by Alex Meyer <ameyer@phoenix.Princeton.EDU>
	for computer science senior thesis
	16 April 1992 -- created
	21 April 1992 -- put defines in structs.h & added setFile/close
	22 April 1992 -- centralized filename extension
*****/

#import <objc/hashtable.h>
#import <objc/Object.h>

#define FILEEXT ("trnscrpt")

typedef struct {
	unsigned type;
	NXAtom key;
	NXAtom desc;
	unsigned statsSize;
	void *Stats;	/* private copy */
} tmRec,*tmPtr;

@interface TranscriptManager : Object
{
	id storage;
	BOOL fileValid;
	NXAtom fileName;
}

- setFile:(NXAtom)fName;
- close;
- load;
- save;
- (unsigned)addRecord:(tmPtr)rec;
- (unsigned)numRecords;
- copyRecordIndex:(unsigned)ind
	into:(tmPtr)dst;
- copyRecordKey:(NXAtom)key
	ofType:(unsigned)type
	into:(tmPtr)dst
	where:(unsigned *)Ind;
- (BOOL)findIndex:(unsigned *)Ind
	ofKey:(NXAtom)key
	andType:(unsigned)type;
- copyIndex:(unsigned)ind
	statsFrom:(void *)Stats;

@end
