/***** TranscriptLinker.h -- liason object interface
	NeXTstep Measurement Kit
	by Alex Meyer <ameyer@phoenix.Princeton.EDU>
	for computer science senior thesis
	16 April 1992 -- created
	23 April 1992 -- added central LINKERNAME
	24 April 1992 -- added info about linked objects
*****/

#import <objc/hashtable.h>
#import <objc/Storage.h>
#import "TranscriptManager.h"
#import <objc/Object.h>

#define LINKERNAME ("RLinker")

typedef struct {
	id obj;	/* linked object (see below) */
	unsigned type;
	NXAtom key;
	unsigned index;	/* for random access via TranscriptManager */
} tlRec,*tlPtr;

@interface TranscriptLinker : Object
{
	id manager;
	id storage;	/* of links */
}

- connect:sender;

@end

/* linked objects must implement the following methods:
	- (unsigned)type;
	- (NXAtom)key;
	- (NXAtom)desc;
	- (unsigned)statsSize;
	- (void *)copyOfStats;
	- copyInStats:(void *)NewStats;
*/
