/* =======================================================
	Neural Network Classes for the NeXT Computer
	Written by: Ralph Zazula
					University of Arizona
					zazula@bonehead.tucson.az.us (NeXT Mail)
==========================================================*/
#import <objc/Object.h>
#import <objc/List.h>

#import "Neuron.h"
#import "Random.h"

@interface BackPropEngine:Object

{
	id	inputs;
	id	hidden;
	id	outputs;
	id	random;
	
	double ETA;
	double ALPHA;
	double Error;
}

- init;
- initWithInputs:(int)Nin hidden:(int)Nhid outputs:(int)Nout;
- applyInput:(double *)input;
- correctWithTarget:(double *)target;
- inputs;
- hidden;
- outputs;
- (double)getEta;
- setEta:(double)newEta;
- (double)getError;

@end