/*--------------------------------------------------------------------------
 *
 * 	You may freely copy, distribute, and reuse the code in this example.
 * 	SHL Systemhouse disclaims any warranty of any kind, expressed or  
 *	implied, as to its fitness for any particular use.
 *
 *
 *	EOFDelegate
 *
 *	Inherits From:		NSObject
 *
 *	Conforms To:		None
 *
 *	Declared In:		EOFDelegate.h
 *
 *	Class Description
 *
 *		EOFDelegate implements all delegate methods contained 
 *		within the EOF framework and provides a means by which
 *		to trace these notification sequences.
 *
 *		Delegate methods that allow a choice of return values
 *		optionally invoke an alert panel so that the user may
 *		have a chance to interactively determine the delegate's
 *		response.  Default values that do not effect the normal
 *		EOF processing sequence will be returned wherever possible.
 *
 *		Implementation of this class has been divided into categories
 *		for readability.  There are separate [.hm] files for each.
 *		The categories are Adaptor, Database, and Controller and 
 *		correspond to major component pieces of EOF.
 *
 *
 *------------------------------------------------------------------------*/
#import <eointerface/eointerface.h>
#import <eoaccess/eoaccess.h>
#import <foundation/NSObject.h>
#import <appkit/appkit.h>
#import "AppController.h"




@interface EOFDelegate : NSObject
{
}

@end
