/*--------------------------------------------------------------------------
 *
 * 	You may freely copy, distribute, and reuse the code in this example.
 * 	SHL Systemhouse disclaims any warranty of any kind, expressed or  
 *	implied, as to its fitness for any particular use.
 *
 *	Author
 *
 *	Inherits From:		NSObject
 *
 *	Conforms To:		None
 *
 *	Declared In:		Author.h
 *
 *	Class Description
 *
 *		Author is our enterprise object for the database entity
 *		authors in the Sybase pubs database (this is specified via
 *		EOModeler.app).
 *
 *		This class demonstrates how an enterprise object uses the
 *		EOKeyValueCoding protocol to transfer values to / from the 
 *		database (see that informal protocol doc for more info).
 *		Here's what happens to our ivars:
 *
 *		au_id		will be filled in automatically (ivar match)
 *		fullname	will use set / get accessors
 *		address		will use set / get accessors and call Address object
 *		
 *		
 *------------------------------------------------------------------------*/
#import <foundation/NSObject.h>

@class NSMString;
@class Address;



@interface Author : NSObject
{
	NSString	*au_id;
	NSString	*fullname;
	Address		*address;
}

/*--------------------------------------------------------------------------
 *	Accessors
 *------------------------------------------------------------------------*/
- (NSString *) fullname;
- (NSString *) address;
- (NSString *) city;
- (NSString *) state;
- (NSString *) zip;

- (void) setFullname: (NSString *)aName;
- (void) setAddress: (NSString *)anAddress;
- (void) setCity: (NSString *)aCity;
- (void) setState: (NSString *)aState;
- (void) setZip: (NSString *)aZip;


@end	
	