/*--------------------------------------------------------------------------
 *
 * 	You may freely copy, distribute, and reuse the code in this example.
 * 	SHL Systemhouse disclaims any warranty of any kind, expressed or  
 *	implied, as to its fitness for any particular use.
 *
 *
 *	SlidingMatrix
 *
 *	Inherits From:		Matrix
 *
 *	Conforms To:		None.
 *
 *	Declared In:		SlidingMatrix.h
 *
 *	Class Description
 *
 *		This is an adaption of Thomas Burkholder's Ranker class found
 *		in NeXT's MiniExamples. I have modified it to support its usage
 *		in custom IB connectors (added delegate notification when a
 *		row change takes place,  reworked row exchange).
 *
 *
 *------------------------------------------------------------------------*/
#import <appkit/appkit.h>




@interface SlidingMatrix : Matrix
{
	id	delegate;
}


@end



/*--------------------------------------------------------------------------
 *
 *	SlidingMatrixDelegate
 *
 *	Category Of:		Object
 *
 *	Declared In:		SlidingMatrix.h
 *
 *	Category Description
 *
 *		description
 *
 *
 *------------------------------------------------------------------------*/

@interface Object (SlidingMatrixDelegate)

- (BOOL) slidingMatrix: sender  willSlideFromRow: (int) sourceRow;
- (BOOL) slidingMatrix: sender  willSlideToRow: (int) destinationRow;
- slidingMatrix: sender  didSlideFromRow: (int) sourceRow 
			toRow: (int) destinationRow;

@end

