/*--------------------------------------------------------------------------
 *
 * 	You may freely copy, distribute, and reuse the code in this example.
 * 	SHL Systemhouse disclaims any warranty of any kind, expressed or  
 *	implied, as to its fitness for any particular use.
 *
 *
 *	ObjectController
 *
 *	Inherits From:		Object
 *
 *	Conforms To:		None
 *
 *	Declared In:		ObjectController.h
 *
 *------------------------------------------------------------------------*/

#import <appkit/appkit.h>
#import <foundation/foundation.h>
#import <eointerface/eointerface.h>



@interface ObjectController : Object
{
	/*
	 * Main window items
	 */
	id	objectTypeSelector;
	id	objectWell;
	id	swapView;
	id	window;

	/*
	 * General stuff
	 */
	id
		theObject;
	NSString
		*filename;

	/*
	 * NSArray window items
	 */
	id	arrayReceiverWell;
	id	arrayBrowserView;
	id	arrayWindow;

	/*
	 * NSDictionary window items
	 */
	id	dictionaryReceiverWell;
	id	dictionaryKeyForm;
	id	dictionaryTableView;
	id	dictionaryWindow;

	/*
	 * NSString window items
	 */
	id	stringReceiverWell;
	id	stringTextView;
	id	stringWindow;
}

/*--------------------------------------------------------------------------
 *	General...
 *------------------------------------------------------------------------*/

- initWithContentsOfFile: (NSString *) theFilename;
- showWindow;
- changeObjectType: sender;
- save: sender;
- close: sender;



/*--------------------------------------------------------------------------
 *	Working as an NSArray...
 *------------------------------------------------------------------------*/

- initWithArray: (NSArray *) theArray;
- addObjectToArray: sender;
- arrayBrowserDoubleClick: sender;



/*--------------------------------------------------------------------------
 *	Working as an NSDictionary...
 *------------------------------------------------------------------------*/

- initWithDictionary: (NSDictionary *) theDictionary;
- addKeyAndObjectToDictionary: sender;
- dictionaryTableViewDoubleClick: sender;



/*--------------------------------------------------------------------------
 *	Working as an NSString...
 *------------------------------------------------------------------------*/

- initWithString: (NSString *) theString;

@end