

#define XQ_OPEN_OK		0
#define XQ_OPEN_COPY		1
#define XQ_OPEN_READONLY	3

#define XQ_TOO_FEW_ARGUMENTS_FUNCTION	-1
#define XQ_TOO_MANY_ARGUMENTS_FUNCTION	-2
#define XQ_UNDEFINED_FUNCTION		-3
#define XQ_EXECUTION_ERROR		-4

#import <objc/Object.h>

@interface XQ_Interface:Object
{
	id	theSpeaker;
	id	theListener;
	id	theDelegate;
}

- initForCurrentSheet;
- initForNewSheet;
- initForSheet: (STR)path type: (int)type;

- setDelegate:delegate;
- delegate;

- (int)XQ_sendValues: valueList
	fromRow: (int)fr
	fromCol: (int)fc
	toRow: (int)tr
	toCol: (int)tc
	ok: (int *)ok;

- (int)XQ_getValues: valueList
	fromRow: (int)fr
	fromCol: (int)fc
	toRow: (int)tr
	toCol: (int)tc
	ok: (int *)ok;

- (int)XQ_callFunction: (const char *)fnName
	arguments: argList
	returnValue: (id *)returnValue
	error: (int *)error;

- (int)XQ_makeKeyAndOrderFront;
- (int)XQ_recalculate;
- (int)XQ_redisplay;
- (int)XQ_save;
- (int)XQ_saveAs: (const char *)path;
- (int)XQ_close;
- (int)XQ_hide;

-(int)XQ_getPath:(char **)buf;

- (BOOL)isSheetAlive;

- (int)XQ_sheetWillClose;
- (int)XQ_sheetWasSaved: (int)type;
- (int)XQ_sheetDidBecomeEdited;
- (int)XQ_sheetDataDidChange;

@end






#import <appkit/Listener.h>
@interface XQ_InterfaceListener : Listener
{}
-(int)XQ_createNewSheet : (port_t *) aSendPort
	sendPort : (port_t) aListenPort
	ok : (int *) ok;
-(int)XQ_openSheet : (char *) path
	type : (int) type
	listenPort : (port_t *) aSendPort
	sendPort : (port_t) aListenPort
	ok : (int *) ok;
-(int)XQ_currentSheetListenPort : (port_t *) aSendPort
	sendPort : (port_t) aListenPort
	ok : (int *) ok;
-(int)XQ_sendData : (char *) buf
	len : (int) len
	fromRow : (int) fromRow
	fromCol : (int) fromCol
	toRow : (int) toRow
	toCol : (int) toCol
	ok : (int *) ok;
-(int)XQ_getData : (char **) buf
	len : (int *) len
	fromRow : (int) fromRow
	fromCol : (int) fromCol
	toRow : (int) toRow
	toCol : (int) toCol
	ok : (int *) ok;
-(int)XQ_getPath : (char **) buf;
-(int)XQ_makeKeyAndOrderFront;
-(int)XQ_recalculate;
-(int)XQ_redisplay;
-(int)XQ_close;
-(int)XQ_save;
-(int)XQ_saveAs : (char *) path;
-(int)XQ_hide;
-(int)XQ_callFunction : (char *) fnName
	args : (char *) argBug
	argLen : (int) argLen
	error : (int *) error
	result : (char **) returnBuf
	len : (int *) retLen;
-(int)XQ_sheetWillClose;
-(int)XQ_sheetWasSaved : (int) type;
-(int)XQ_sheetDidBecomeEdited;
-(int)XQ_sheetDataDidChange;
-(int)XQ_clientWillFree;
@end
#import <appkit/Speaker.h>
@interface XQ_InterfaceSpeaker : Speaker
{}
-(int)XQ_createNewSheet : (port_t *) aSendPort
	sendPort : (port_t) aListenPort
	ok : (int *) ok;
-(int)XQ_openSheet : (char *) path
	type : (int) type
	listenPort : (port_t *) aSendPort
	sendPort : (port_t) aListenPort
	ok : (int *) ok;
-(int)XQ_currentSheetListenPort : (port_t *) aSendPort
	sendPort : (port_t) aListenPort
	ok : (int *) ok;
-(int)XQ_sendData : (char *) buf
	len : (int) len
	fromRow : (int) fromRow
	fromCol : (int) fromCol
	toRow : (int) toRow
	toCol : (int) toCol
	ok : (int *) ok;
-(int)XQ_getData : (char **) buf
	len : (int *) len
	fromRow : (int) fromRow
	fromCol : (int) fromCol
	toRow : (int) toRow
	toCol : (int) toCol
	ok : (int *) ok;
-(int)XQ_getPath : (char **) buf;
-(int)XQ_makeKeyAndOrderFront;
-(int)XQ_recalculate;
-(int)XQ_redisplay;
-(int)XQ_close;
-(int)XQ_save;
-(int)XQ_saveAs : (char *) path;
-(int)XQ_hide;
-(int)XQ_callFunction : (char *) fnName
	args : (char *) argBug
	argLen : (int) argLen
	error : (int *) error
	result : (char **) returnBuf
	len : (int *) retLen;
-(int)XQ_sheetWillClose;
-(int)XQ_sheetWasSaved : (int) type;
-(int)XQ_sheetDidBecomeEdited;
-(int)XQ_sheetDataDidChange;
-(int)XQ_clientWillFree;
@end
