#import <appkit/appkit.h>
#import <remote/NXProxy.h>	/* setProtocolForProxy */
#import <machkit/senderIsInvalid.h>

@class NSString;


@interface STAppClient:Object <NXSenderIsInvalid>
{
	id remoteServer;
	NSString *serverName;
	Protocol *proto;
}

/* class methods - designated creator */
+ connectToApp:(NSString *)anAppName usingProtocol:(Protocol *)aProtocol;


/* these two methods should be called only once in the
    beginning to set the servername and the protocol.
	Afterwards, if the server quits, we can use these
	values to reconnect.
*/
- setProtocol:aProtocol;

/* serverName is the actual name of the app!!! */
- setServerName:(NSString *)anAppName;

/* establish the connection to the server app */
- getRemoteServer;

- senderIsInvalid:sender;

/* return the proxy object */
- remoteServer;


@end

