
/* STAppController.h - written by Robert Vasvari 6/94 */
#import <appkit/appkit.h>
#import <foundation/NSObject.h>
#import <foundation/NSZone.h>
@class NSString, NSArray, NSMutableArray;

@interface STAppController:Object
{
	NSMutableArray *docArray; //contains all open document objects
	id currentDoc;	 //document that has the key window
	id prefManager;
	id inspectorManager;
	id infoPanel;
	id versionText;
	NXZone *controllerZone; //used to allocate all global stuff
	id accessoryView; //in the save panel

	/* menu cells */
	id documentMenu;
	id toolsMenu;
	id editMenu;
	id windowsMiniaturize;
	id windowsClose;
	id editDelete;
}

/* ==== init section ==== */
- init;
- appDidInit:sender;

/* ==== document management section ==== */
- openFile:sender;
- documentClass;
- (NSArray *)docExtensions;
- createDocumentObject:sender;
- openDocument:(NSString *)aPath;
- newDocument:sender;
- save:sender;
- saveAs:sender;
- saveTo:sender;
- saveAll:sender;
- revert:sender;
- close:sender;
- freeDoc:aDoc;
- findDocWithPath:(NSString *)aPath;
- findDocWithTag:(int)aTag;

/* ==== panels ==== */
- getPrefsPanel:sender;
- getInspectorPanel:sender;
- (BOOL)getInspectorPanelWithScreen:(int)aScreen;
- getInfoPanel:sender;

/* ==== access to instance variables ==== */
- setCurrentDoc:aDoc;
- currentDoc;

/* ==== application delegate methods ==== */
- (BOOL)appAcceptsAnotherFile:sender;
- (int)appOpenFile:(const char *)path type:(const char *)type;
- appWillTerminate:sender;


@end
