
/*  STDocumentClass.h written by Robert Vasvari, Oct 1994.
	This class is a generic document that has its own nibfile.
	The Document object comes with: name,path and window. Also,
	it implements some of the most basic document handling
	methods that most apps need.
 */

#import <appkit/appkit.h>
#import <foundation/NSString.h>
#import <foundation/NSDate.h>

@interface STDocumentClass:NSObject
{
	id window;
	NSString *documentName, *documentPath;
	int tag;
	NSCalendarDate *createTime, *lastModifyTime;
}


/* ==== init section ==== */
+ newDocument;
- (NSString *)nibName;
- init;
- awakeFromNib;

/* ==== access to instance variables ==== */
- window;
- (int)tag;
- setTag:(int)aTag;
- (NSString *)documentName;
- (NSString *)documentPath;
- setDocumentName:(NSString *)aName;
- setDocumentPath:(NSString *)aPath;
- getInspectorData:(NSString **)nm :(NSString **)pth :(int *)t
		:(NSCalendarDate **)ct :(NSCalendarDate **)lt;

/* ==== file handling ==== */
- (BOOL)openDocumentFile:(NSString *)aPath;
- readAttributes:(NXStream *)st;
- saveDocument;
- saveDocumentAs:(NSString *)aPath;
- saveDocumentTo:(NSString *)aPath;
- writeAttributes:(NXStream *)st;
- documentModified:sender;

/* ==== Window delegate methods ==== */
- windowDidBecomeKey:sender;
- windowWillClose:sender;
- windowDidUpdate:sender;
- windowDidResize:sender;

- (void)dealloc;
@end
