#import <foundation/NSString.h>

#import "STNibExtensions.h"

/* 	these methods are necessary to be able to instantiate
	an NSObject subclass from IB
 */

@implementation NSObject (NibExtensions)

- perform:(SEL)aSelector with:anObject
{	
	//printf("in %s %s\n",[(Object *)[self class] 
	//				name], sel_getName(_cmd));

	if(aSelector && anObject)[self perform:aSelector withObject:anObject];
	return self;
}

+ (const char *)name
{	return [[self description] cString];
}

+ (BOOL)_canAlloc
{	return YES;
}

- (BOOL)respondsTo:(SEL)aSelector
{	return [self respondsToSelector:aSelector];
}

- (BOOL)isKindOf:aClass
{	return [self isKindOfClass:aClass];
}

- (BOOL)isMemberOf:aClass
{	return [self isMemberOfClass:aClass];
}



@end
