#import "MultDoc.h"
#import <appkit/drag.h>

/* Version 0.9b		Apr-19-92		First Public Release	*/
/* Version 0.95		Apr-29-92		Multiple Save Types		*/
/* Version 1.0b		Aug-08-92		Minor Bug Fixes			*/
/* Version 1.1b		Jan-20-93		Drag And Drop			*/

@interface BriefDoc : MultDoc
{
	BOOL	dragOK;						// Are the types acceptable?
}

/* Factory Creation Methods */

+ initialize;
+ newFromFile:(const char *)file;

- setUpNib;
- instanceAwake;

/* Public methods */

- addFiles:(char *)fileList;

/* Document name and file handling methods */

- save;

/* Text delegate methods */

- textDidGetKeys:sender isEmpty:(BOOL)flag;

/* Drag and Drop methods */

- (NXDragOperation)draggingEntered:(id <NXDraggingInfo>)sender;
- (NXDragOperation)draggingUpdated:(id <NXDraggingInfo>)sender;
- draggingExited:(id <NXDraggingInfo>)sender;
- (BOOL)prepareForDragOperation:(id <NXDraggingInfo>)sender;
- (BOOL)performDragOperation:(id <NXDraggingInfo>)sender;
- concludeDragOperation:(id <NXDraggingInfo>)sender;

@end
