// GameInfo.h -- This object allows you to set global parameters that
// 		affect the GameKit in various ways.

#import <appkit/appkit.h>

@interface GameInfo:Object <NXTransport>
{
	int numSounds, numSoundTypes, numSoundStreams;
	int maxHighScores, numHighScoreTables, *maxHighScoresPerPlayer;
	int numOneUps;
	id  slotType;
	id  encryptedPassword;
}

- init;					// inits with GameKit defaults
- free;

- dumpToLog:aLogFile;	// used by server when logging

// The following methods access stored info.
- slotType;					// For the high score system
- (int)maxHighScores;		// for the high score system
- (int)numHighScoreTables;	// for the high score system
- encryptedPassword;		// For network high score table access
- (int)numSounds;			// for the sound system
- (int)numSoundTypes;		// for the sound system
- (int)numSoundStreams;		// for the sound system
- (int)numOneUps;			// how many "men" you start with
- (int)maxScoresPerPlayerTable:(int)theTable net:(BOOL)which;
	// max # of highscores allowed for a player in a given table (theTable)
	// and specify via "which" if net or local server. (0 == no limit)

// The following methods change stored info.  All return self.
- setMaxScoresPerPlayerTable:(int)theTable net:(BOOL)which to:(int)val;
	// sets values; like -maxScoresPerPlayerTable:net: above
- setnumSoundTypes:(int)anInt;
- setnumSoundStreams:(int)anInt;
- setnumSounds:(int)anInt;
- setnumHighScoreTables:(int)anInt;
- setMaxHighScores:(int)anInt;
- setSlotType:(const char *)aString;
- setEncryptedPassword:(const char *)aString;
- setNumOneUps:(int)oneUps;

// for archiving to/from a file
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;

// Interface Builder support
- (const char *)getInspectorClassName;
- (NXImage *)getIBImage;

@end		
