/* 
    File: Gif.h

    Written by: Georges CHAN

    Purpose: header file for Gif.m defines constant and
             global variables used in Gif.m

    Copyright, All right reserved.

    Feel free to use this application.

    Date: July 92

    Note: The author disclaims all warranties with regard to this
          software, including all implied warranties or merchantability,
          in no event shall the author be liable for any special,
          indirect or consequential damages or any damages whatsoever
          resulting from loss of use, data or profits, whether in an
          action of contract, negligence or other tortuous action,
          arising out of or in connection with the use of this software.

          GIF is the copyright property of CompuServe Inc.,
          GIF (sm) is a service mark property of CompuServe Inc.

*/


/* Generated by Interface Builder */

#import <objc/Object.h>

#define FNAMELEN 20  // maximum length of file name
#define MAXLEN 100   // maximum length of full path name + file name

#define MAXIPERGIF 30 // max number of images per GIF
#define MAXWIN 50     // max number of windows

@interface Gif:Object
{
    char home[MAXLEN];     // hold the whole path of the application
    NXSize screamSize;     // size of the screen
    NXCoord winX,          // x coordinate where to put the displayed window
            winY;          // y coordinate where to put the displayed window
    int winNum,            // remember the window number
        cuNo[MAXWIN],      // remember image number currently displayed
        noIm[MAXWIN],      // remember number of images in a GIF
        useOrigin,         // flag to tell demo to use origin as described in GIF file
        useScreenSize,     // flag to tell demo to use the screen size as described in the GIF file
        command;           // hold composite type for doing composite of NXImages
    id picture[MAXWIN][MAXIPERGIF],  // list of bit maps (or NXImage)
       win[MAXWIN],                  // window to display images of a GIF file
       composeBut;

}

- load:sender;
- save:sender;
- changeOrigin:sender;
- animate:sender;

@end
