/*

     File: GifDecode.h

     Release: 1.0

     Written by: Georges CHAN

     Purpose: declare GifDecode class.

     Copyright, All right reserved.

     Feel free to use this application.

     Date: July 92

     Note: The author disclaims all warranties with regard to this
           software, including all implied warranties or merchantability,
           in no event shall the author be liable for any special,
           indirect or consequential damages or any damages whatsoever
           resulting from loss of use, data or profits, whether in an
           action of contract, negligence or other tortuous action,
           arising out of or in connection with the use of this software.

           GIF is the copyright property of CompuServe Inc.,
           GIF (sm) is a service mark property of CompuServe Inc.


*/

#import <objc/Object.h>
#import <appkit/graphics.h>      // lib for graphics constant type, e.g. NXRect

@interface GifDecode:Object
{
    unsigned char gMap[256][3],  // hold RGB color for global color map
                  lMap[256][3],  // hold RGB color for local color map
                  shade[4096],   // hold color index in decoding table
                  stack[4096];   // hold colors to stack up for output
    int child[4096],             // hold child of each entry in decoding table
        backIndex,               // index of background color
        left,                    // number of bits left in buffer
        safe,                    // value of the bits left in buffer
        nvc,                     // next valid code (i.e. next index to fill an entry in table)
        oldCode,                 // last code processed in decoding process
        color,                   // last color decoded in decoding process
        cSize,                   // number of bits to deal when starting decoding
        stackIndex,              // number of entries pushed in stack
        useGMap,                 // use global color map flag
        gEntry,                  // number of entries in global color map
        lEntry,                  // number of entries in local color map
        oldVer;                  // flag for old version (GIF 87a); set to zero for GIF 89a
}

- initFromFile :(const char *) filename
       bitList :(id *) mapList
        maxiNo :(int) maxi
     noOfFrame :(int *) noImage
       winSize :(NXSize *) screenSize
    useOrCoord :(int) useOr;

- initFromFile :(const char *) filename
     imageList :(id *) imList
        maxiNo :(int) maxi
     noOfFrame :(int *) noImage
       winSize :(NXSize *) screenSize
    useOrCoord :(int) useOr;

@end
