/*
 * Copyright 1993 by Cub'x Systemes
 * 
 * All Rights Reserved
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for the  purpose of making new intuitiv'3d modules.
 * This copyright notice must appears in all copies that you distribute.
 * The name of Cub'x Systeme should not be used in advertising or publicity
 * without specific, written prior permission. 
 * CUB'X SYSTEMES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * CUB'X SYSTEMES BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */
 

/******************************************************************************* 
 *                                                                             *
 *     Project intuitiv'3d                                                     *
 *     -------------------                                                     *
 *                                                                             *
 *                                                                             *
 *     File: ColoredPlan.h                                                     *
 *                                                                             *
 *                                                                             *
 *     Creation date: Mon Jul 26 11:52:40 GMT+0200 1993                        *
 *                                                                             *
 *                                                                             *
 *     Contents:  A plan that includes colors or opacity parameters            *
 *                This object is made to be an example illustrating the        *
 *                CX3DAttributeInsp object                                     *
 *                                                                             *
 *******************************************************************************/


#import <i3d/CX3DObject.h>
#import <i3d/CX3DAttributeInsp.h>

@interface ColoredPlan : CX3DObject
{
  float   size;
  NXColor up_left,up_right,down_left,down_right;
  BOOL    use_opacity;
}

/*******************************************************************************
 *                                                                             *
 *                                Class methods                                *
 *                                                                             *
 *******************************************************************************/
+ initialize;
+ (ExportedVariable*) exportedVariable;

/*******************************************************************************
 *                                                                             *
 *                               Instance methods                              *
 *                                                                             *
 *******************************************************************************/

- init;
- copy;
- render;
- getBoundingBox:(RtBound) aBox;

- setSize:(float*) v;
- size:(float*) v;
- getMinValue:(float*)v;
- getMaxValue:(float*)v;

- setRedValueUL:  (float*) v;
- setGreenValueUL:(float*) v;
- setBlueValueUL: (float*) v;
- setRedValueUR:  (float*) v;
- setGreenValueUR:(float*) v;
- setBlueValueUR: (float*) v;
- setRedValueDL:  (float*) v;
- setGreenValueDL:(float*) v;
- setBlueValueDL: (float*) v;
- setRedValueDR:  (float*) v;
- setGreenValueDR:(float*) v;
- setBlueValueDR: (float*) v;

- getRedValueUL:  (float*) v;
- getGreenValueUL:(float*) v;
- getBlueValueUL: (float*) v;
- getRedValueUR:  (float*) v;
- getGreenValueUR:(float*) v;
- getBlueValueUR: (float*) v;
- getRedValueDL:  (float*) v;
- getGreenValueDL:(float*) v;
- getBlueValueDL: (float*) v;
- getRedValueDR:  (float*) v;
- getGreenValueDR:(float*) v;
- getBlueValueDR: (float*) v;

- setUseOpacity:(BOOL) aFlag;
- (BOOL) useOpacity;

- attributeInspClass;
- (AIParameter*) AIparameters;
- (const char*) inspectorName;


@end
