/*
 * Copyright 1993 by Cub'x Systemes
 * 
 * All Rights Reserved
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for the  purpose of making new intuitiv'3d modules.
 * This copyright notice must appears in all copies that you distribute.
 * The name of Cub'x Systeme should not be used in advertising or publicity
 * without specific, written prior permission. 
 * CUB'X SYSTEMES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * CUB'X SYSTEMES BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */
 

/******************************************************************************* 
 *                                                                             *
 *     Project intuitiv'3d                                                     *
 *     -------------------                                                     *
 *                                                                             *
 *                                                                             *
 *     File: Shiny.m                                                           *
 *                                                                             *
 *                                                                             *
 *     Creation date: Mon Jul 26 11:52:40 GMT+0200 1993                        *
 *                                                                             *
 *                                                                             *
 *     Contents:  A CX3DEnvmapShader subclass example.                         *
 *                                                                             *
 *******************************************************************************/

#import "Shiny.h"

@implementation Shiny : CX3DEnvmapShader

/*
 *  This method should init the shader with the shader class name
 *  that you want to use
 */
- init
{
  /*
   *  Since initWithShaderClassName call -init we have to use
   *  a variable inInit
   */
  if(!inInit)
    {
      inInit = YES;
      [super init];
      [super initWithShaderClassName:"shiny"];
      inInit = NO;
      /*
       *  The tiff DefaultSurface is inside the main bundle
       */
      [self setIconFromMachO:"DefaultSurface"]; 
    }
  return self;
}

/*
 *  This method should return the address of the parameter
 *  that is the environment map.
 */
- (CXArg*) environMapArg
{
  return &arg[3];
}

@end
