/*
 * Copyright 1993 by Cub'x Systemes
 * 
 * All Rights Reserved
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for the  purpose of making new intuitiv'3d modules.
 * This copyright notice must appears in all copies that you distribute.
 * The name of Cub'x Systeme should not be used in advertising or publicity
 * without specific, written prior permission. 
 * CUB'X SYSTEMES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * CUB'X SYSTEMES BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */
/******************************************************************************* 
 *                                                                             *
 *     Project intuitiv'3d                                                     *
 *     -------------------                                                     *
 *                                                                             *
 *                                                                             *
 *     File: SkyInspector.h                                                    *
 *                                                                             *
 *                                                                             *
 *     Creation date: Tue Jul 27 14:42:12 GMT+0200 1993                        *
 *                                                                             *
 *                                                                             *
 *     Contents: a sky inspector.                                              *
 *                                                                             *
 *                                                                             *
 *******************************************************************************/
#import <i3d/i3d_api.h>
#import <i3d/CX3DGenericShaderInspector.h>

/*
 *  Here we must use the old name of GenericShaderInspector since
 *  interface builder parses the name into the interface definition
 */
@interface SkyInspector : GenericShaderInspector
{
  id box;
  id lightBlueW;
  id darkBlueW;
  id weatherS;
}

+ alloc;
- (BOOL)shouldUseArg:(unsigned int) argNum;
- (BOOL)shouldUseScale;
- makeInterfaceBeforeAllAt:(NXCoord*) py;
- uninit;

- lightBlueChange:sender;
- darkBlueChange: sender;
- weatherChange: sender;
@end


