/*
 * Copyright 1993 by Cub'x Systemes
 * 
 * All Rights Reserved
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for the  purpose of making new intuitiv'3d modules.
 * This copyright notice must appears in all copies that you distribute.
 * The name of Cub'x Systeme should not be used in advertising or publicity
 * without specific, written prior permission. 
 * CUB'X SYSTEMES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * CUB'X SYSTEMES BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */
/******************************************************************************* 
 *                                                                             *
 *     Project AdvancedObject                                                  *
 *     ----------------------                                                  *
 *                                                                             *
 *                                                                             *
 *     File:SlideProjectorInsp.h                                               *
 *                                                                             *
 *                                                                             *
 *     Creation date:Fri Jul 30 15:25:35 GMT+0200 1993                         *
 *                                                                             *
 *                                                                             *
 *     Contents: An attribute inspector for the slide projector light          *
 *                                                                             *
 *                                                                             *
 *******************************************************************************/

#import <i3d/InspectorView.h>


@interface SlideProjectorInsp : InspectorView
{
  id imageFilet;
  id fieldOfViewt;
  id upXt;
  id upYt;
  id upZt;
  id shadowc;
  id shadowDetailt;
}

/*******************************************************************************
 *                                                                             *
 *                                Class methods                                *
 *                                                                             *
 *******************************************************************************/
+ (const char*)nibName;

/*******************************************************************************
 *                                                                             *
 *                                  Interface                                  *
 *                                                                             *
 *******************************************************************************/
- fieldOfViewChange: sender;
- upXChange: sender;
- upYChange: sender;
- upZChange: sender;
- imageFileChange: sender;
- setImageFile: sender;
- shadowChange: sender;
- shadowDetailChange: sender;

/*******************************************************************************
 *                                                                             *
 *                               Instance methods                              *
 *                                                                             *
 *******************************************************************************/
- sendAllValueToObject: anObject;
- receiveAllValueFromObject: anObject;
- (const char*) title;

@end



