/*
 * Copyright 1993 by Cub'x Systemes
 * 
 * All Rights Reserved
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for the  purpose of making new intuitiv'3d modules.
 * This copyright notice must appears in all copies that you distribute.
 * The name of Cub'x Systeme should not be used in advertising or publicity
 * without specific, written prior permission. 
 * CUB'X SYSTEMES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * CUB'X SYSTEMES BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */

/*****************************************************************************
 *
 *  CustomObject module
 *  -------------------
 *
 * File: Co.h
 *
 * Contents: An i3dModule subclass 
 *     
 *
 *****************************************************************************/
/*
 *  All i3dm text section should include at least one I3dModule
 *  subclass. This class is used to describe the section inside the
 *  intuitiv'3d library (which name / object / icons ... ).
 */

#import <i3d/I3dModule.h>


@interface Co : I3dModule
{
}

+ (SectionType) requestedSectionType;
+ fillObjectList:(List*) aList;
+ (const char*) moduleName;
+ (const char*) unselectedImage;
+ (const char*) selectedImage;

@end







