/*
 * Copyright 1993 by Cub'x Systemes
 * 
 * All Rights Reserved
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for the  purpose of making new intuitiv'3d modules.
 * This copyright notice must appears in all copies that you distribute.
 * The name of Cub'x Systeme should not be used in advertising or publicity
 * without specific, written prior permission. 
 * CUB'X SYSTEMES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * CUB'X SYSTEMES BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */

/*****************************************************************************
 *
 *  CustomObject module
 *  -------------------
 *
 * File: DistortedCube.h
 *
 * Contents: A distorted cube class
 *     
 *
 *****************************************************************************/

#import <i3d/CX3DObject.h>


@interface DistortedCube : CX3DObject
{
  float startWidth;
  float startHeight;
  float destWidth;
  float destHeight;
  float offsetForX;
  float offsetForY;
  float offsetForZ;
}


/*******************************************************************************
 *                                                                             *
 *                                Class methods                                *
 *                                                                             *
 *******************************************************************************/

+ initialize;
+ (ExportedVariable *)exportedVariable;



/*******************************************************************************
 *                                                                             *
 *                               Instance methods                              *
 *                                                                             *
 *******************************************************************************/

- init;
- copy;
- render;
- getBoundingBox:(RtBound)aBox;
- setStartWidth:(float)aFloat;
- (float)startWidth;
- setStartHeight:(float)aFloat;
- (float)startHeight;
- setDestWidth:(float)aFloat;
- (float)destWidth;
- setDestHeight:(float)aFloat;
- (float)destHeight;
- setOffsetForX:(float)aFloat;
- (float)offsetForX;
- setOffsetForY:(float)aFloat;
- (float)offsetForY;
- setOffsetForZ:(float)aFloat;
- (float)offsetForZ;
- attributeInspClass;



@end


