/*
 * Copyright 1993 by Cub'x Systemes
 * 
 * All Rights Reserved
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for the  purpose of making new intuitiv'3d modules.
 * This copyright notice must appears in all copies that you distribute.
 * The name of Cub'x Systeme should not be used in advertising or publicity
 * without specific, written prior permission. 
 * CUB'X SYSTEMES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * CUB'X SYSTEMES BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */

/*****************************************************************************
 *
 *  CustomObject module
 *  -------------------
 *
 * File: DistortedCubeInsp.h
 *
 * Contents: A distorted cube inspector
 *     
 *
 *****************************************************************************/

#import <i3d/InspectorView.h>


@interface DistortedCubeInsp : InspectorView
{
    id startWidthSlider;
    id startWidthTextField;
    id startHeightSlider;
    id startHeightTextField;
    id destWidthSlider;
    id destWidthTextField;
    id destHeightSlider;
    id destHeightTextField;
    id offsetForXSlider;
    id offsetForXTextField;
    id offsetForYSlider;
    id offsetForYTextField;
    id offsetForZSlider;
    id offsetForZTextField;
}


/*******************************************************************************
 *                                                                             *
 *                                Class methods                                *
 *                                                                             *
 *******************************************************************************/
+ (const char*)nibName;

/*******************************************************************************
 *                                                                             *
 *                               Instance methods                              *
 *                                                                             *
 *******************************************************************************/
/*
 *  Instance methods to be compatible with intuitiv'3d's inspector protocol.
 */
- (const char *)title;
- sendAllValueToObject:anObject;
- receiveAllValueFromObject:anObject;


/*
 *  Target / action methods. Please see DistortedCubeInsp.nib
 */
- takeStartWidthFrom:sender;
- takeStartHeightFrom:sender;
- takeDestWidthFrom:sender;
- takeDestHeightFrom:sender;
- takeOffsetForXFrom:sender;
- takeOffsetForYFrom:sender;
- takeOffsetForZFrom:sender;




@end
