/*
 * Copyright 1993 by Cub'x Systemes
 * 
 * All Rights Reserved
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for the  purpose of making new intuitiv'3d modules.
 * This copyright notice must appears in all copies that you distribute.
 * The name of Cub'x Systeme should not be used in advertising or publicity
 * without specific, written prior permission. 
 * CUB'X SYSTEMES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * CUB'X SYSTEMES BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */

/*****************************************************************************
 *
 *  CustomObject module
 *  -------------------
 *
 * File: TorusWave.h
 *
 * Contents: A TorusWave object from the book "The RenderMan companion" Steve
 *           Upstill Addison Wesley
 *
 *****************************************************************************/

#import <i3d/CX3DObject.h>
#import <ri/ri.h>

@interface TorusWave : CX3DObject
{
  unsigned int waveCount; /* Number of waves that you want to display */
  float    thetamax;      /* The torus thetamax                      */
  float    radius;        /* The torus wave radius                   */
}

/*******************************************************************************
 *                                                                             *
 *                                Class methods                                *
 *                                                                             *
 *******************************************************************************/

+ initialize;
+ (ExportedVariable*) exportedVariableFor:(long)version;

/*******************************************************************************
 *                                                                             *
 *                               Instance methods                              *
 *                                                                             *
 *******************************************************************************/

- init;
- copy;
- render;
- getBoundingBox:(RtBound) aBox;


- setWaveCount:(unsigned int) aValue;
- (unsigned int) waveCount;

- setThetamax: (float) aFloat;
- (float) thetamax;

- setRadius: (float) aFloat;
- (float) radius;

- attributeInspClass;


@end

