/*
 *  A sky shader from the shader clouds  
 * 
 */
surface sky   (float    Kd=.8, Ka=.2 ,weather = 1;
	       color    lightBlue = color(.25, .83 , 1 ),
	                darkBlue  = color(.33, .58 , .86 );)
{
    float sum ;
    float i, freq;
    color clouds_color;
    
    if( weather < 0 )
      freq = 0.001;
    else if( weather > 10 )
      freq = 10;
    else
      freq = weather;

    clouds_color = color( 1.0 , 1.0 , 1.0 );
    sum = 0; 
    for (i = 0; i < 6; i = i + 1) {
        sum = sum + 1/freq * abs(.5 - noise( freq * P)) ;
        freq = 2 * freq;
    }
    Ci = mix(mix( darkBlue , lightBlue, t  ), clouds_color, sum * 4);
    Oi = 1.0;       
}

