/*
 * Copyright 1993 by Cub'x Systemes
 * 
 * All Rights Reserved
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for the  purpose of making new intuitiv'3d modules.
 * This copyright notice must appears in all copies that you distribute.
 * The name of Cub'x Systeme should not be used in advertising or publicity
 * without specific, written prior permission. 
 * CUB'X SYSTEMES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * CUB'X SYSTEMES BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */
/******************************************************************************* 
 *                                                                             *
 *     Project intuitiv'3d                                                         *
 *     ---------------                                                         *
 *                                                                             *
 *                                                                             *
 *     File: CX3DEnvmapShader.h                                                *
 *                                                                             *
 *                                                                             *
 *     Creation date: Tue Jul 27 14:33:53 GMT+0200 1993                        *
 *                                                                             *
 *                                                                             *
 *     Contents:An abstract superclass to handle environmap shaders            *
 *                                                                             *
 *                                                                             *
 *******************************************************************************/



#import <i3d/CX3DShader.h>

@interface CX3DEnvmapShader : CX3DShader
{
  char *envMapBuff;
  BOOL shouldUseEnvMap;
  float detailLevel;
}

+ (ExportedVariable*) exportedVariable;
- awake;
- init;
- copy;
- initParametersFromShader: anObject;
- free;
- preRender: displayer;
- postRender: displayer;
- (BOOL) shouldUseTextcoord;
- (BOOL)   shouldUseEnvMap;
- setUseEnvMap:(BOOL) flag;
- convertTranslation:(float*) p forObject: anObject;
- setDetailLevel: (float) aFloat;
- (float) detailLevel;

/*
 *  Inspectors
 */
- inspectorClass;

/*****************************************************************************
 *                                                                           *
 * Methods implemented by the subclass                                       *
 *                                                                           *
 *****************************************************************************/
- (CXArg*) environMapArg;

@end

