/*
 * Copyright 1993 by Cub'x Systemes
 * 
 * All Rights Reserved
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for the  purpose of making new intuitiv'3d modules.
 * This copyright notice must appears in all copies that you distribute.
 * The name of Cub'x Systeme should not be used in advertising or publicity
 * without specific, written prior permission. 
 * CUB'X SYSTEMES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * CUB'X SYSTEMES BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */
/******************************************************************************* 
 *                                                                             *
 *     Project 3-Dream                                                         *
 *     ---------------                                                         *
 *                                                                             *
 *                                                                             *
 *     File: CX3DGenericShaderInspector.h                                      *
 *                                                                             *
 *                                                                             *
 *     Creation date: Tue Jul 27 14:47:04 GMT+0200 1993                        *
 *                                                                             *
 *                                                                             *
 *     Contents:  A generic inspector for shaders                              *
 *                                                                             *
 *                                                                             *
 *******************************************************************************/

#import <appkit/View.h>
#import <i3d/CX3DShader.h>

#define DEFAULT_OFFSET 2
#define DEFAULT_WIDTH  270

@interface GenericShaderInspector : View
{
  id interfaceList;
  id target;
  id shader;
  SEL action;
  BOOL useDispBound;
  CXArg dispBound;
}

+ alloc;
- free;
- (BOOL)shouldUseArg:(unsigned int) argNum;
- (BOOL)shouldUseScale;
- makeInterfaceBeforeAllAt:(NXCoord*) py;
- initForShader: aShader;
- uninit;
- aValueHaveChange: sender;
- setTarget: aTarget;
- target;
- setAction:(SEL) anAction;
- (SEL) action;

@end
