/*
 * Copyright 1993 by Cub'x Systemes
 * 
 * All Rights Reserved
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for the  purpose of making new intuitiv'3d modules.
 * This copyright notice must appears in all copies that you distribute.
 * The name of Cub'x Systeme should not be used in advertising or publicity
 * without specific, written prior permission. 
 * CUB'X SYSTEMES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * CUB'X SYSTEMES BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */
/******************************************************************************* 
 *                                                                             *
 *     Project intuitiv'3d                                                     *
 *     -------------------                                                     *
 *                                                                             *
 *                                                                             *
 *     File: N3DLightSource.h                                                  *
 *                                                                             *
 *                                                                             *
 *     Creation date: Mon Jul 26 17:48:04 GMT+0200 1993                        *
 *                                                                             *
 *                                                                             *
 *     Contents: An abstract class to implement a light                        *
 *                                                                             *
 *                                                                             *
 *******************************************************************************/
#import <i3d/CX3DObject.h>
#import <i3d/CX3DAttributeInsp.h>

@interface N3DLightSource : N3DObject
{
  BOOL isConstLight;
  BOOL showQuickRepresentation;
  BOOL haveBeenPlaced;
  RtPoint from,to,oldTo;
  BOOL moveTo;
  NXColor color;
}

+ (ExportedVariable*) exportedVariable;
- init;
- copy;
- render;
- illuminate;
- (BOOL) isALight;
- (BOOL) isSelectable;


- setConstLight: (BOOL) flag;
- (BOOL) isConstLight;

- showQuickRepresentation:(BOOL) flag;
- (BOOL) showQuickRepresentation;

- setLightOn:(BOOL) flag;
- (BOOL) isOn;

- setHaveBeenPlaced:(BOOL) flag;
- (BOOL) haveBeenPlaced;

- setFromX:(float) x Y:(float) y Z:(float)z;
- getFromX:(float*)x Y:(float*)y Z:(float*)z;
- setToX:(float)   x Y:(float) y Z:(float)z;
- getToX:(float*)  x Y:(float*)y Z:(float*)z;
- setMoveTo:(BOOL) flag;
- (BOOL) moveTo;
- saveCurrentTranslation;
- getOldToX: (float*) x Y: (float*) y Z: (float*) z;

- (BOOL) willAcceptShader: anObject;

- setColor:(NXColor) aColor;
- (NXColor) color;
- acceptColor:(NXColor)co atPoint:(const NXPoint *)aPoint;
@end






