/*
 * Copyright 1993 by Cub'x Systemes
 * 
 * All Rights Reserved
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for the  purpose of making new intuitiv'3d modules.
 * This copyright notice must appears in all copies that you distribute.
 * The name of Cub'x Systeme should not be used in advertising or publicity
 * without specific, written prior permission. 
 * CUB'X SYSTEMES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * CUB'X SYSTEMES BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */
/******************************************************************************* 

/*****************************************************************************
 *
 *      CXSavePanel.h
 *
 *			NS Library (CXSavePanel class).
 *
 *
 *
 *      ---
 *      20-MAR-93   Hubert Delahaye (hubert) 
 *                  -> Created
 *
 *****************************************************************************/



#ifndef _NSLIB_CXSAVEPANEL_H_
#define _NSLIB_CXSAVEPANEL_H_



#import <appkit/SavePanel.h>



/*****************************************************************************
 * CXSavePanel interface. 
 *****************************************************************************/

@interface CXSavePanel : SavePanel
{
	id fileReminder;
}



/* ========================================================================= *
 * Class methods.
 * ========================================================================= */

+ initialize;
+ new;



/* ========================================================================= *
 * Instance methods. 
 * ========================================================================= */

- browser;

- registerSelectedFile;

- setRequiredFileType:(const char *)fileType;

- (int)runModal;
- (int)runModalForDirectory:(const char *)path file:(const char *)name;



@end



#endif /* _NSLIB_CXSAVEPANEL_H_ */



