/*
 * Copyright 1993 by Cub'x Systemes
 * 
 * All Rights Reserved
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for the  purpose of making new intuitiv'3d modules.
 * This copyright notice must appears in all copies that you distribute.
 * The name of Cub'x Systeme should not be used in advertising or publicity
 * without specific, written prior permission. 
 * CUB'X SYSTEMES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * CUB'X SYSTEMES BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */
/***************************************************************************** 
 *                                                                           *
 *   Project intuitiv 3d                                                     *
 *   -------------------                                                     *
 *                                                                           *
 *                                                                           *
 *   File: ExportedVariable.h                                                *
 *                                                                           *
 *                                                                           *
 *   Creation date: Wed Dec 16 10:25:57 GMT 1992                             *
 *                                                                           *
 *                                                                           *
 *   Contents: Definition to export variables                                *
 *                                                                           *
 *                                                                           *
 *****************************************************************************/

#ifndef _EXPORTED_VARIABLE_H
#define _EXPORTED_VARIABLE_H

#import <objc/typedstream.h>

/*
 *  Variable type
 */
#define EV_FLOAT      @encode(float)
#define EV_DOUBLE     @encode(double)
#define EV_CHAR       @encode(char)
#define EV_UCHAR      @encode(unsigned char)
#define EV_SHORT      @encode(short)
#define EV_LONG       "l"
#define EV_ULONG      @encode(unsigned long)
#define EV_INT        @encode(int)
#define EV_UINT       @encode(unsigned int)
#define EV_BOOL       @encode(BOOL)
#define EV_BYTES_DATA "c" /* This is for backward compatibility, please do not use */
#define EV_OBJECT     "@"
#define EV_3DPOINT    "[3f]"
#define EV_NXCOLOR    "!NXColor"

#define EV_NULL       NULL

typedef struct _ExportedVariable
{
  char * variableName;              /* Variable name */
  char * variableType;              /* Variable type */
  unsigned long variableLength;     /* size when using EV_BYTES_DATA */
                                    /* or tab size */
} ExportedVariable;



extern void evWriteVariableForObject(NXTypedStream *s,id obj);
extern void evReadVariableForObject(NXTypedStream  *s,id obj);
extern void CXWriteString(NXTypedStream *s,const char *str);
extern char *CXReadAllocatedString(NXTypedStream *s);


#endif



