/*
 * Copyright 1993 by Cub'x Systemes
 * 
 * All Rights Reserved
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for the  purpose of making new intuitiv'3d modules.
 * This copyright notice must appears in all copies that you distribute.
 * The name of Cub'x Systeme should not be used in advertising or publicity
 * without specific, written prior permission. 
 * CUB'X SYSTEMES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * CUB'X SYSTEMES BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */
/******************************************************************************* 
 *                                                                             *
 *     Project intuitiv'3d                                                     *
 *     -------------------                                                     *
 *                                                                             *
 *                                                                             *
 *     File: I3dModule.h                                                       *
 *                                                                             *
 *                                                                             *
 *     Creation date: Mon Jul 26 17:39:18 GMT+0200 1993                        *
 *                                                                             *
 *                                                                             *
 *     Contents:Id3Module abstract class definition                                                               *
 *                                                                             *
 *                                                                             *
 *******************************************************************************/



#import <objc/Object.h>
#import <objc/List.h>

typedef enum
{
  ST3DObject = 0,
  STShader   = 1
} SectionType;

@interface I3dModule : Object
{
  
}

/*****************************************************************************
 *                                                                           *
 *  Interface with Intuitiv 3d                                               *
 *                                                                           *
 *****************************************************************************/
/*
 *  Returns the requested section type
 */
+ (SectionType) requestedSectionType;

/*
 *  Fill the list with default instances of classes that you want to add
 *  Theses classes should inherit of CX3DObject or CX3DShader according to
 *  the requestedSectionType return value.
 */
+ fillObjectList:(List*) aList;

/*
 *  This methods returns the module name
 */
+ (const char*) moduleName;

/*
 *  This methods returns the name of the tiff used for the unselected image of the
 *  section (This tiff should be in your .i3dm directory)
 *  Please return NULL if you don't have any image for now
 */
+ (const char*) unselectedImage;

/*
 *  This methods returns the name of the tiff used for the selected image of the
 *  section (This tiff should be in your .i3dm directory)
 *  Please return NULL if you don't have any image for now
 */
+ (const char*) selectedImage;


+ (BOOL) isDefaultSection;
@end
