/*
 * Copyright 1993 by Cub'x Systemes
 * 
 * All Rights Reserved
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for the  purpose of making new intuitiv'3d modules.
 * This copyright notice must appears in all copies that you distribute.
 * The name of Cub'x Systeme should not be used in advertising or publicity
 * without specific, written prior permission. 
 * CUB'X SYSTEMES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * CUB'X SYSTEMES BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */
/******************************************************************************* 
 *                                                                             *
 *     Project intuitiv'3d                                                     *
 *     -------------------                                                     *
 *                                                                             *
 *                                                                             *
 *     File: InspectorView.h                                                   *
 *                                                                             *
 *                                                                             *
 *     Creation date: Mon Jul 26 17:41:34 GMT+0200 1993                        *
 *                                                                             *
 *                                                                             *
 *     Contents: An abstract super class for all inspector sections            *
 *                                                                             *
 *                                                                             *
 *******************************************************************************/

#import <appkit/View.h>

@interface InspectorView : View
{
  /*
   *  The real view used inside InterfaceBuilder
   */
  id  ibView;
}

+ new;
+ findInspector: aClass;
+ (const char*) nibName;
+ CXstartUnloading;
/*****************************************************************************
 *                                                                           *
 * Methods to be compatible with the main inspector                          *
 *                                                                           *
 *****************************************************************************/

- sendAllValueToObject: anObject;
- receiveAllValueFromObject: anObject;
- (const char*) title;
+ (BOOL) isOkForMultipleSelection;

@end

#define UPDATE_OBJECT_IF_NEED(method,parameter)\
  {if( [window isRealTime] )\
    {\
       [[window currentObject] method (parameter)];\
       [[window currentScene] forceDisplayScene];\
    }}

#define INSPECTOR_IS_REAL_TIME ([window isRealTime])
#define INSPECTED_OBJECT       ([window currentObject])
#define UPDATE_SCENE           {[[window currentScene] forceDisplayScene];}



