/*
 * Copyright 1993 by Cub'x Systemes
 * 
 * All Rights Reserved
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for the  purpose of making new intuitiv'3d modules.
 * This copyright notice must appears in all copies that you distribute.
 * The name of Cub'x Systeme should not be used in advertising or publicity
 * without specific, written prior permission. 
 * CUB'X SYSTEMES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * CUB'X SYSTEMES BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */
/******************************************************************************* 
 *                                                                             *
 *     Project intuitiv'3d                                                     *
 *     -------------------                                                     *
 *                                                                             *
 *                                                                             *
 *     File: NodeView.h                                                        *
 *                                                                             *
 *                                                                             *
 *     Creation date: Tue Jul 27 14:25:55 GMT+0200 1993                        *
 *                                                                             *
 *                                                                             *
 *     Contents:An ObjectView is an abstract super-class used to display the   *
 *     instance of a conceptual object as an icon.                             *
 *                                                                             *
 *                                                                             *
 *******************************************************************************/

#import <i3d/ObjectView.h>

@interface NodeView : ObjectView
{
  id objList;
  id altImage;
  BOOL isOpened;
  BOOL customAltImage;
}

- init;
- copy;
- free;
- realFree;

- altImage;
- setAltImage: anImage;
- setAltIconFromMachO:(const char*) name;
- setAltIconFromFile: (const char*) name;
- setAltIconByName:   (const char*) name;
- swapImages;

- addObject: anObject;
- insertObjectAt0: anObject;
- remObject: anObject;
- objectTitled:(const char*) aTitle;
- objList;


/*
 *  Methods to accept a new object
 */
- (BOOL) willAcceptObject: anObject;
- openSelf:(BOOL) flags;
- (BOOL)isOpened;


/*****************************************************************************
 *                                                                           *
 *           Method to be the delegate of owned object                       *
 *                                                                           *
 *****************************************************************************/
- (BOOL) sonWillChangeTitle: sender : (const char*) title;

/*******************************************************************************
 *                                                                             *
 *                             Reading and writing                             *
 *                                                                             *
 *******************************************************************************/
- read:(NXTypedStream*)s;
- write:(NXTypedStream*)s;
- awake;

@end
