/******************************************************************************* 
 *                                                                             *
 *     Project <MyProject>                                                     *
 *     -------------------                                                     *
 *                                                                             *
 *                                                                             *
 *     File: <MyFile.m>                                                        *
 *                                                                             *
 *                                                                             *
 *     Creation date:                                                          *
 *                                                                             *
 *                                                                             *
 *     Contents:                                                               *
 *                                                                             *
 *                                                                             *
 *******************************************************************************/

#import <i3d/InspectorView.h>


@interface MyInspectorView : InspectorView
{
}

/*******************************************************************************
 *                                                                             *
 *                                Class methods                                *
 *                                                                             *
 *******************************************************************************/
/*
 *  This method should return the name of the nib file that you want to
 *  use with the inspector.
 */
+ (const char*)nibName;

/*******************************************************************************
 *                                                                             *
 *                               Instance methods                              *
 *                                                                             *
 *******************************************************************************/
/*
 *  This method should send all inspector values to the object
 *  This method is called when the user presses the Ok button.
 */
- sendAllValueToObject: anObject;

/*
 *  This method should set the inspector's interface to the 
 *  value of anObject. This method is called when there is
 *  a new object selection or when the user presses the
 *  revert button.
 */
- receiveAllValueFromObject: anObject;

/*
 *   This method should returns the name of the inspector
 */
- (const char*) title;

@end




