/******************************************************************************* 
 *                                                                             *
 *     Project <MyModule>                                                      *
 *     ---------------                                                         *
 *                                                                             *
 *                                                                             *
 *     File:                                                                   *
 *                                                                             *
 *                                                                             *
 *     Creation date:                                                          *
 *                                                                             *
 *                                                                             *
 *     Contents:                                                               *
 *                                                                             *
 *                                                                             *
 *******************************************************************************/

/*
 *  All i3dm text section should include at least one I3dModule
 *  subclass. This class is used to describe the section inside the
 *  intuitiv'3d library (which name / object / icons ... ).
 */

#import "MyModule.h"


@implementation MyModule 

/*
 *  Returns the requested section type
 */
+ (SectionType) requestedSectionType
{
  /*
   *  Return ST3DObject if you want to see your section in the object 
   *  library or STShader if you want to see your section in the shader 
   *  library
   */
  return ?;
}

/*
 *  This method should fill the list with default instances of classes that
 *  you want to add. Theses classes should inherit of CX3DObject or CX3DShader
 *  according to the requestedSectionType return value.
 */
+ fillObjectList:(List*) aList
{
  [aList addObject: ... ];
  return self;
}

/*
 *  This method returns the module name
 */
+ (const char*) moduleName
{
  return "My module name";
}

/*
 *  This method returns the name of the tiff used for the unselected image of the
 *  section (This tiff should be in your bundle)
 *  Please return NULL if you don't have any image.
 */
+ (const char*) unselectedImage
{
  return NULL;
}

/*
 *  This method returns the name of the tiff used for the selected image of the
 *  section (This tiff should be in your .i3dm directory)
 *  Please return NULL if you don't have any image.
 */
+ (const char*) selectedImage
{
  return NULL;
}

@end



