// Applications interface definition for use with TclObj.
// Copyright 1991 Manticore, Inc.  All Rights Reserved.
// 
// You may freely copy, distribute and reuse the code in this example.
// Manticore disclaims any warranty of any kind, expressed or
// implied, as to its fitness for any particular use.

#import "TclApp.h"


// The following is a list of definitions of 'C' procedures that
// can be called from Tcl. The first item in each entry is the
// name that the procedure is known by in Tcl. The second item is
// a pointer to the actual procedure. The third argument is a description
// of the procedure's calling sequence. See the comments in TclApp.m for
// a description of this string.

extern NXBeep();
extern NXGetDefaultValue();
extern NXWriteDefault();
extern NXRemoveDefault();
extern NXGetObjectName();
extern NXGetNamedObject();
extern NXMouseInRect();
extern NXSetRect();

TCLARGS tclProcInitTab[] = {
	"beep", NXBeep, " ",
	"send", (IPROC)objc_msgSend, "",
	"getDefaultValue", NXGetDefaultValue, "***",
	"writeDefault", NXWriteDefault, " ***",
	"removeDefault", NXRemoveDefault, " **",
	"getClassId", (IPROC)objc_getClass, "@*",
	"getObjectName", NXGetObjectName, "*@",
	"getNamedObject", NXGetNamedObject, "@*@",
	"selGetUid", (IPROC)sel_getUid, "i*",
	"selGetName", (IPROC)sel_getName, "*i",
	"mouseInRect", NXMouseInRect, "ipqi",
	"setRect", NXSetRect, " Qffff",
	NULL, NULL, ""
};
